#
# this module look for mcf support
# it will define the following values
#
# MCF_INCLUDE_DIR = where boost.h can be found
#
# May want to define this but seldom required
# MCF_LIBRARY = where mcf library can be found (reserved)
#
IF(MCF_INCLUDE_DIRS)
  FIND_PATH(MCF_INCLUDE_DIR mcf.h  ${MCF_INCLUDE_DIRS})
ELSE(MCF_INCLUDE_DIRS)

  SET(TRIAL_PATHS
    $ENV{MCF_HOME}/lib
    /usr/local
  )

  SET(TRIAL_INCLUDE_PATHS
    $ENV{MCF_HOME}/include
  )
  FIND_PATH(MCF_INCLUDE_DIR mcf.h ${TRIAL_INCLUDE_PATHS})
  FIND_LIBRARY(MCF_LIBRARY StormRT-v3.2.1 ${TRIAL_PATHS})
ENDIF(MCF_INCLUDE_DIRS)

IF(MCF_INCLUDE_DIR)
  SET(FOUND_MCF 1 CACHE BOOL "Found mcf library")
ELSE(MCF_INCLUDE_DIR)
  SET(FOUND_MCF 0 CACHE BOOL "Found mcf library")
ENDIF(MCF_INCLUDE_DIR)

MARK_AS_ADVANCED(
   MCF_INCLUDE_DIR
   MCF_LIBRARY 
   FOUND_MCF
)
