#!/usr/bin/env perl
# convert from NRL to OHMMS format
# units are converted to eV and AA
# only two species
$i=0;
$iv = 0;
$ia = 0;
$ib = 0;
$iab = 0;
$iba = 0;
$iha = 0;
$ihb = 0;
$ihab = 0;
$isa = 0;
$isb = 0;
$isab = 0;

$rydberg = 13.6058;
$bohr = 0.529177;
#$rydberg = 1.0;
#$bohr = 1.0;
$bohrinv = 1.0/$bohr;
$zero = 0.0;

while(<>) {
chop($_);
@pos = split(' ');
if($i == 0) {
    $nrltype=$pos[0];
}
if($i == 2) {
    $nspecies = $pos[0];
} 
if($i == 3) {
    $rcut = $pos[0]*$bohr;
    $screen = $pos[1]*$bohr;
} 
if($i == 6) {
    $norb = $pos[0];
} 
if($i == 7) {
    $massa = $pos[0];
}
if($i == 10) {
    $massb = $pos[0];
}
if($i == 12) {
    $lama = $pos[0]*$pos[0]*$bohrinv;
}
if($i > 12 && $i<29) {
    $ax[$ia] = $pos[0]*$rydberg;
    $ia++;
}
if($i == 29) {
    $lamb = $pos[0]*$pos[0]*$bohrinv;
}
if($i > 29 && $i<46) {
    $bx[$ib] = $pos[0]*$rydberg;
    $ib++;
}
if($i >= 46 && $i<58) {
    $abx[$iab] = $pos[0]*$rydberg;
    $iab++;
}
if($i >= 58 && $i<70) {
    $bax[$iba] = $pos[0]*$rydberg;
    $iba++;
}
if($i >= 70 && $i < 110) {
    $ha[$iha] = $pos[0];
    $iha++;
} 
if($i >= 110 && $i < 150) {
    $hb[$ihb] = $pos[0];
    $ihb++;
}
if($i >= 150 && $i < 206) {
    $hab[$ihab] = $pos[0];
    $ihab++;
}
if($i >= 206 && $i < 246) {
    $sa[$isa] = $pos[0];
    $isa++;
}
if($i >= 246 && $i < 286) {
    $sb[$isb] = $pos[0];
    $isb++;
}
if($i >= 286) {
    $sab[$isab] = $pos[0];
    $isab++;
}
$i++;
}

print "\#TBPARAM for NRL potential\n";
print "\#Converted for OHMMS package\n";
print "\#Generated by Utility/nrltb1.ev.pl written by Jeongnim Kim\n";

$hu[0] = $rydberg;
$hu[1] = $rydberg*$bohrinv;
$hu[2] = $rydberg*$bohrinv*$bohrinv; 
$hu[3] = $bohrinv;
if($nrltype == "NN00001") {
    $su[0] = $bohrinv;
    $su[1] = $bohrinv*$bohrinv;
    $su[2] = $bohrinv*$bohrinv*$bohrinv;
} else {
    $su[0] = 1.0;
    $su[1] = $bohrinv;
    $su[2] = $bohrinv*$bohrinv;
}
$su[3] = $bohrinv;
$suab[0] = 1.0;
$suab[1] = $bohrinv;
$suab[2] = $bohrinv*$bohrinv;

#species
printf "<species>\n";
printf "<name> Si </name>\n";
printf "<mass> $massa </mass>\n";
printf "<valence> 4 </valence>\n";
printf "<orbital> 0 </orbital>\n";
printf "<orbital> 1 </orbital>\n";
    if($norb == 9) {
	printf "<orbital> 2 </orbital>\n";
    }
printf "</species>\n";

printf "<species>\n";
printf "<name> C </name>\n";
printf "<mass> $massb </mass>\n";
printf "<valence> 4 </valence>\n";
printf "<orbital> 0 </orbital>\n";
printf "<orbital> 1 </orbital>\n";
    if($norb == 9) {
	printf "<orbital> 2 </orbital>\n";
    }
printf "</species>\n";

#onsite terms are separated 
printf "<onsite name=\"nrl\">\n";
printf "bond Si Si\n";
printf "rcut    =  $rcut\n";
printf "screenl =  $screen\n";
printf "lambda  =  $lama\n";
if($norb == 9) {
  printf "density 4\n";
} else {
  printf "density 2\n";
}

printf ("0 0 %20.12e %20.12e %20.12e %20.12e\n", $zero, $ax[1], $ax[2], $ax[3]);
printf ("1 1 %20.12e %20.12e %20.12e %20.12e\n", $zero, $ax[5], $ax[6], $ax[7]);

if($norb == 9) {
    printf ("2 4 %20.12e %20.12e %20.12e %20.12e\n", $zero, $ax[9], $ax[10], $ax[11]);
    $crystal = $ax[12]-$ax[8];
    printf ("2 6 %20.12e %20.12e %20.12e %20.12e\n", $crystal, $ax[13], $ax[14], $ax[15]);
}

printf "bond Si C\n";
printf "rcut    =  $rcut\n";
printf "screenl =  $screen\n";
printf "lambda  =  $lamb\n";
if($norb == 9) {
  printf "density 4\n";
} else {
  printf "density 2\n";
}

printf ("0 0 %20.12e %20.12e %20.12e %20.12e\n", $zero, $abx[0], $abx[1], $abx[2]);
printf ("1 1 %20.12e %20.12e %20.12e %20.12e\n", $zero, $abx[3], $abx[4], $abx[5]);

if($norb == 9) {
    printf ("2 4 %20.12e %20.12e %20.12e %20.12e\n", $zero, $abx[6], $abx[7], $abx[8]);
    printf ("2 6 %20.12e %20.12e %20.12e %20.12e\n", $zero, $abx[9], $abx[10], $abx[11]);
}

printf "bond C Si\n";
printf "rcut    =  $rcut\n";
printf "screenl =  $screen\n";
printf "lambda  =  $lama\n";
if($norb == 9) {
  printf "density 4\n";
} else {
  printf "density 2\n";
}

printf ("0 0 %20.12e %20.12e %20.12e %20.12e\n", $zero, $bax[0], $bax[1], $bax[2]);
printf ("1 1 %20.12e %20.12e %20.12e %20.12e\n", $zero, $bax[3], $bax[4], $bax[5]);

if($norb == 9) {
    printf ("2 4 %20.12e %20.12e %20.12e %20.12e\n", $zero, $bax[6], $bax[7], $bax[8]);
    printf ("2 6 %20.12e %20.12e %20.12e %20.12e\n", $zero, $bax[9], $bax[10], $bax[11]);
}

printf "bond C C\n";
printf "rcut    =  $rcut\n";
printf "screenl =  $screen\n";
printf "lambda  =  $lamb\n";
if($norb == 9) {
  printf "density 4\n";
} else {
  printf "density 2\n";
}

printf ("0 0 %20.12e %20.12e %20.12e %20.12e\n", $zero, $bx[1], $bx[2], $bx[3]);
printf ("1 1 %20.12e %20.12e %20.12e %20.12e\n", $zero, $bx[5], $bx[6], $bx[7]);

if($norb == 9) {
    printf ("2 4 %20.12e %20.12e %20.12e %20.12e\n", $zero, $bx[9], $bx[10], $bx[11]);
    $crystal = $bx[12]-$bx[8];
    printf ("2 6 %20.12e %20.12e %20.12e %20.12e\n", $crystal, $bx[13], $bx[14], $bx[15]);
}

printf "</onsite>\n";

#slater-koster parameters start here
printf "<TBPARAM name=\"nrl\">\n";
printf "$nrltype\n";

###############################################
# starting A-A bond
###############################################
printf "bond Si Si\n";
printf "rcut     =  $rcut\n";
printf "screenl  =  $screen\n";

$ic=0;
sub print_hs_a{
    my $va, $vb, $vc, $vd;
    my $sa, $sb, $sc, $sd;
    $va = $ha[$ic]*$hu[0]; 
    $sa = $sa[$ic]*$su[0];
    $ic++;
    $vb = $ha[$ic]*$hu[1]; 
    $sb = $sa[$ic]*$su[1];
    $ic++;
    $vc = $ha[$ic]*$hu[2]; 
    $sc = $sa[$ic]*$su[2];
    $ic++;
    $vd = $ha[$ic]*$ha[$ic]*$hu[3]; 
    $sd = $sa[$ic]*$sa[$ic]*$su[3];
    $ic++;
    printf ("%20.12e %20.12e %20.12e %20.12e\n", $va, $vb, $vc, $vd);
    printf ("%20.12e %20.12e %20.12e %20.12e\n", $sa, $sb, $sc, $sd);
}

printf ("0 0 -1 0 0 %20.12e \#s-onsite\n", $ax[0]);
printf "0 0 0 0 0 \#ss-sig\n";
print_hs_a;
printf "0 1 0 0 1 \#sp-sig\n";
print_hs_a;

printf ("1 1 -1 1 1 %20.12e \#p-onsite\n", $ax[4]);
printf "1 1 0 1 1 \#pp-sig\n";
print_hs_a;


printf "1 1 1 1 1 \#pp-pi\n";
print_hs_a;

if($norb == 9) {
    printf "0 2 0 0 4 \#sd-sig\n";
    print_hs_a;

    printf "1 2 0 1 4 \#pd-sig\n";
    print_hs_a;

    printf "1 2 1 1 4 \#pd-pi\n";
    print_hs_a;

    printf ("2 2 -1 4 4 %20.12e \#d-onsite\n", $ax[8]);

    printf "2 2 0 4 4 \#dd-sig\n";
    print_hs_a;

    printf "2 2 1 4 4 \#dd-pi\n";
    print_hs_a;

    printf "2 2 2 4 4 \#dd-del\n";
    print_hs_a;
}

###############################################
# starting A-B bond
###############################################
printf "bond Si C\n";
printf "rcut     =  $rcut\n";
printf "screenl  =  $screen\n";

$ic=0;
sub print_hs_ab{
    my $va, $vb, $vc, $vd;
    my $sa, $sb, $sc, $sd;
    $va = $hab[$ic]*$hu[0]; 
    $sa = $sab[$ic]*$suab[0];
    $ic++;
    $vb = $hab[$ic]*$hu[1]; 
    $sb = $sab[$ic]*$suab[1];
    $ic++;
    $vc = $hab[$ic]*$hu[2]; 
    $sc = $sab[$ic]*$suab[2];
    $ic++;
    $vd = $hab[$ic]*$hab[$ic]*$hu[3]; 
    $sd = $sab[$ic]*$sab[$ic]*$su[3];
    $ic++;
    printf ("%20.12e %20.12e %20.12e %20.12e\n", $va, $vb, $vc, $vd);
    printf ("%20.12e %20.12e %20.12e %20.12e\n", $sa, $sb, $sc, $sd);
}

printf "0 0 0 0 0 \#ss-sig\n";
print_hs_ab;
printf "0 1 0 0 1 \#sp-sig\n";
print_hs_ab;

printf "1 1 0 1 1 \#pp-sig\n";
print_hs_ab;


printf "1 1 1 1 1 \#pp-pi\n";
print_hs_ab;

if($norb == 9) {
    printf "0 2 0 0 4 \#sd-sig\n";
    print_hs_ab;

    printf "1 2 0 1 4 \#pd-sig\n";
    print_hs_ab;

    printf "1 2 1 1 4 \#pd-pi\n";
    print_hs_ab;

    printf "2 2 0 4 4 \#dd-sig\n";
    print_hs_ab;

    printf "2 2 1 4 4 \#dd-pi\n";
    print_hs_ab;

    printf "2 2 2 4 4 \#dd-del\n";
    print_hs_ab;
} else {
    $ic += 24;
}

printf "1 0 0 1 0 \#ps-sig\n";
print_hs_ab;
if($norb == 9) {
    printf "2 0 0 4 0 \#ds-sig\n";
    print_hs_ab;

    printf "2 1 0 4 1 \#dp-sig\n";
    print_hs_ab;

    printf "2 1 1 4 1 \#dp-pi\n";
    print_hs_ab;
}

#############################################
#starting B-A bond
#############################################
printf "bond C Si\n";
printf "rcut     =  $rcut\n";
printf "screenl  =  $screen\n";

$ic=0;
printf "0 0 0 0 0 \#ss-sig\n";
print_hs_ab;
printf "1 0 0 1 0 \#ps-sig\n";
###############################
# need to flip the sign
###############################
$hab[$ic] = -$hab[$ic];
$hab[$ic+1] = -$hab[$ic+1];
$hab[$ic+2] = -$hab[$ic+2];
$sab[$ic] = -$sab[$ic];
$sab[$ic+1] = -$sab[$ic+1];
$sab[$ic+2] = -$sab[$ic+2];
print_hs_ab;

printf "1 1 0 1 1 \#pp-sig\n";
print_hs_ab;


printf "1 1 1 1 1 \#pp-pi\n";
print_hs_ab;

if($norb == 9) {
    printf "2 0 0 4 0 \#ds-sig\n";
    print_hs_ab;

    printf "2 1 0 4 1 \#dp-sig\n";
    print_hs_ab;

    printf "2 1 1 4 1 \#dp-pi\n";
    print_hs_ab;

    printf "2 2 0 4 4 \#dd-sig\n";
    print_hs_ab;

    printf "2 2 1 4 4 \#dd-pi\n";
    print_hs_ab;

    printf "2 2 2 4 4 \#dd-del\n";
    print_hs_ab;
} else {
    $ic += 24;
}

###############################
# need to flip the sign
###############################
$hab[$ic] = -$hab[$ic];
$hab[$ic+1] = -$hab[$ic+1];
$hab[$ic+2] = -$hab[$ic+2];
$sab[$ic] = -$sab[$ic];
$sab[$ic+1] = -$sab[$ic+1];
$sab[$ic+2] = -$sab[$ic+2];
printf "0 1 0 0 1 \#sp-sig\n";
print_hs_ab;
if($norb == 9) {
    printf "0 2 0 0 4 \#sd-sig\n";
    print_hs_ab;

    printf "1 2 0 1 4 \#pd-sig\n";
    print_hs_ab;

    printf "1 2 1 1 4 \#pd-pi\n";
    print_hs_ab;
}

############################################################
# B-B bond
############################################################
printf "bond C C\n";
printf "rcut     =  $rcut\n";
printf "screenl  =  $screen\n";

$ic=0;
sub print_hs_b{
    my $va, $vb, $vc, $vd;
    my $sa, $sb, $sc, $sd;
    $va = $hb[$ic]*$hu[0]; 
    $sa = $sb[$ic]*$su[0];
    $ic++;
    $vb = $hb[$ic]*$hu[1]; 
    $sb = $sb[$ic]*$su[1];
    $ic++;
    $vc = $hb[$ic]*$hu[2]; 
    $sc = $sb[$ic]*$su[2];
    $ic++;
    $vd = $hb[$ic]*$hb[$ic]*$hu[3]; 
    $sd = $sb[$ic]*$sb[$ic]*$su[3];
    $ic++;
    printf ("%20.12e %20.12e %20.12e %20.12e\n", $va, $vb, $vc, $vd);
    printf ("%20.12e %20.12e %20.12e %20.12e\n", $sa, $sb, $sc, $sd);
}

printf ("0 0 -1 0 0 %20.12e \#s-onsite\n", $bx[0]);
printf "0 0 0 0 0 \#ss-sig\n";
print_hs_b;
printf "0 1 0 0 1 \#sp-sig\n";
print_hs_b;

printf ("1 1 -1 1 1 %20.12e \#p-onsite\n", $bx[4]);
printf "1 1 0 1 1 \#pp-sig\n";
print_hs_b;


printf "1 1 1 1 1 \#pp-pi\n";
print_hs_b;

if($norb == 9) {
    printf "0 2 0 0 4 \#sd-sig\n";
    print_hs_b;

    printf "1 2 0 1 4 \#pd-sig\n";
    print_hs_b;

    printf "1 2 1 1 4 \#pd-pi\n";
    print_hs_b;

    printf ("2 2 -1 4 4 %20.12e \#d-onsite\n", $bx[8]);

    printf "2 2 0 4 4 \#dd-sig\n";
    print_hs_b;

    printf "2 2 1 4 4 \#dd-pi\n";
    print_hs_b;

    printf "2 2 2 4 4 \#dd-del\n";
    print_hs_b;
}

printf "</TBPARAM>\n";
