//////////////////////////////////////////////////////////////////
// (c) Copyright 2003- by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#include "Particle/ParticleSet.h"
#include "Message/Communicate.h"
#include "Particle/BulkSystemBuilder.h"
#include "ParticleIO/XMLParticleIO.h"

/***example to create a bulk system using CreateBulkSystem
 *@
 */
using namespace OHMMS;
int main(int argc, char** argv) {

  Controller->initialize(argc,argv);

  if(argc<2) {
    ///no options are given
    CreateBulkSystem::printUsage(cout);
    return 1;
  }

  //====================================================
  //create OhmmsParticle using the options
  //====================================================
  ParticleSet *sys = new ParticleSet;
  CreateBulkSystem::apply(sys,argc,argv);

  //====================================================
  //write OhmmsParticle in xml-format
  //====================================================
  XMLSaveParticle ptclsave(*sys);
  ptclsave.reset("bulk");
  ptclsave.report(0);

  delete sys;
  return 0;
}  
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: makecrystal.cpp 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
  
