//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PARTICLELAYOUTMANAGER_H__
#define OHMMS_PARTICLELAYOUTMANAGER_H__

#include "OhmmsData/OhmmsElementBase.h"
#include "AppBase/OhmmsElementSet.h"

namespace OHMMS {

  /** class ParticleLayout
   *  @brief 
   *    Initialize or reset the particle layout and 
   *    the nearest-neighbor engine.
   */
  class ParticleLayoutManager: public OhmmsElementBase {

  public:

    /// constructors and destructors
    ParticleLayoutManager(OhmmsElementSet& nodelist,
			  const char* aname="particlelayout");
    
    bool get(std::ostream& os) const { return true;}
    bool put(std::istream& is) {return true;}
    bool put(xmlNodePtr cur);
    void reset();

  private:

    ///set of input particle sets
    OhmmsElementSet& NodeList;
  };
}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 253 $   $Date: 2005-01-14 11:40:00 -0600 (Fri, 14 Jan 2005) $
 * $Id: ParticleLayoutManager.h 253 2005-01-14 17:40:00Z jnkim $ 
 ***************************************************************************/
