//////////////////////////////////////////////////////////////////
//                        COPYRIGHT NOTICE
// (c) Copyright 1998-2002 by Dallas Trinkle and Jeongnim Kim
//   All rights reserved.
//////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
/**********************************************************************
 * Adaptation of Dallas' Trinkle repusette.C
 **********************************************************************/
#include "CrystalSymmetry/BCCKPoint.h"

BCCKPoint::BCCKPoint(Lattice_t& lat):KPointBase(lat){

  bcc0 = lat.G(0,1); // save the 1/a
  O.resize(47);
  // adding group operations excluding identity 
  O[ 0]=Tensor_t(-1.,  0.,  0., -1.,  0.,  1., -1.,  1.,  0.);
  O[ 1]=Tensor_t( 0., -1.,  1.,  0., -1.,  0.,  1., -1.,  0.);
  O[ 2]=Tensor_t( 0.,  1., -1.,  1.,  0., -1.,  0.,  0., -1.);
  O[ 3]=Tensor_t( 0.,  1.,  0.,  0.,  0.,  1.,  1.,  0.,  0.);
  O[ 4]=Tensor_t( 0., -1.,  0.,  1., -1.,  0.,  0., -1.,  1.);
  O[ 5]=Tensor_t( 1.,  0., -1.,  0.,  0., -1.,  0.,  1., -1.);
  O[ 6]=Tensor_t(-1.,  0.,  1., -1.,  1.,  0., -1.,  0.,  0.);
  O[ 7]=Tensor_t( 0.,  0.,  1.,  1.,  0.,  0.,  0.,  1.,  0.);
  O[ 8]=Tensor_t( 0.,  0., -1.,  0.,  1., -1.,  1.,  0., -1.);
  O[ 9]=Tensor_t(-1.,  1.,  0., -1.,  0.,  0., -1.,  0.,  1.);
  O[10]=Tensor_t( 1., -1.,  0.,  0., -1.,  1.,  0., -1.,  0.);
  O[11]=Tensor_t( 0., -1.,  0., -1.,  0.,  0.,  0.,  0., -1.);
  O[12]=Tensor_t( 0.,  1.,  0.,  0.,  1., -1., -1.,  1.,  0.);
  O[13]=Tensor_t( 1.,  0., -1.,  1.,  0.,  0.,  1., -1.,  0.);
  O[14]=Tensor_t(-1.,  0.,  1.,  0., -1.,  1.,  0.,  0.,  1.);
  O[15]=Tensor_t(-1.,  0.,  0.,  0.,  0., -1.,  0., -1.,  0.);
  O[16]=Tensor_t( 1.,  0.,  0.,  1., -1.,  0.,  1.,  0., -1.);
  O[17]=Tensor_t( 0., -1.,  1.,  0.,  0.,  1., -1.,  0.,  1.);
  O[18]=Tensor_t( 0.,  1., -1., -1.,  1.,  0.,  0.,  1.,  0.);
  O[19]=Tensor_t( 0.,  0., -1.,  0., -1.,  0., -1.,  0.,  0.);
  O[20]=Tensor_t( 0.,  0.,  1., -1.,  0.,  1.,  0., -1.,  1.);
  O[21]=Tensor_t(-1.,  1.,  0.,  0.,  1.,  0.,  0.,  1., -1.);
  O[22]=Tensor_t( 1., -1.,  0.,  1.,  0., -1.,  1.,  0.,  0.);
  O[23]=Tensor_t(-1.,  0.,  0.,  0., -1.,  0.,  0.,  0., -1.);
  O[24]=Tensor_t( 1.,  0.,  0.,  1.,  0., -1.,  1., -1.,  0.);
  O[25]=Tensor_t( 0.,  1., -1.,  0.,  1.,  0., -1.,  1.,  0.);
  O[26]=Tensor_t( 0., -1.,  1., -1.,  0.,  1.,  0.,  0.,  1.);
  O[27]=Tensor_t( 0., -1.,  0.,  0.,  0., -1., -1.,  0.,  0.);
  O[28]=Tensor_t( 0.,  1.,  0., -1.,  1.,  0.,  0.,  1., -1.);
  O[29]=Tensor_t(-1.,  0.,  1.,  0.,  0.,  1.,  0., -1.,  1.);
  O[30]=Tensor_t( 1.,  0., -1.,  1., -1.,  0.,  1.,  0.,  0.);
  O[31]=Tensor_t( 0.,  0., -1., -1.,  0.,  0.,  0., -1.,  0.);
  O[32]=Tensor_t( 0.,  0.,  1.,  0., -1.,  1., -1.,  0.,  1.);
  O[33]=Tensor_t( 1., -1.,  0.,  1.,  0.,  0.,  1.,  0., -1.);
  O[34]=Tensor_t(-1.,  1.,  0.,  0.,  1., -1.,  0.,  1.,  0.);
  O[35]=Tensor_t( 0.,  1.,  0.,  1.,  0.,  0.,  0.,  0.,  1.);
  O[36]=Tensor_t( 0., -1.,  0.,  0., -1.,  1.,  1., -1.,  0.);
  O[37]=Tensor_t(-1.,  0.,  1., -1.,  0.,  0., -1.,  1.,  0.);
  O[38]=Tensor_t( 1.,  0., -1.,  0.,  1., -1.,  0.,  0., -1.);
  O[39]=Tensor_t( 1.,  0.,  0.,  0.,  0.,  1.,  0.,  1.,  0.);
  O[40]=Tensor_t(-1.,  0.,  0., -1.,  1.,  0., -1.,  0.,  1.);
  O[41]=Tensor_t( 0.,  1., -1.,  0.,  0., -1.,  1.,  0., -1.);
  O[42]=Tensor_t( 0., -1.,  1.,  1., -1.,  0.,  0., -1.,  0.);
  O[43]=Tensor_t( 0.,  0.,  1.,  0.,  1.,  0.,  1.,  0.,  0.);
  O[44]=Tensor_t( 0.,  0., -1.,  1.,  0., -1.,  0.,  1., -1.);
  O[45]=Tensor_t( 1., -1.,  0.,  0., -1.,  0.,  0., -1.,  1.);
  O[46]=Tensor_t(-1.,  1.,  0., -1.,  0.,  1., -1.,  0.,  0.);

}

BCCKPoint::~BCCKPoint(){

}

bool BCCKPoint::build(int *l) {

  if(l) {
    N = SingleParticlePos_t(static_cast<double>(l[0]), 
                            static_cast<double>(l[1]),
                            static_cast<double>(l[2]));
    int a0[3], a1[3], alpha[3];
    for(int i=0; i<3; i++) {
      a0[i] = -l[i];
      a1[i] =  l[i]-1;
      alpha[i]= a0[i];
    }

    double dl = 0.5/static_cast<double>(l[0]);
    double dm = 0.5/static_cast<double>(l[1]);
    double dn = 0.5/static_cast<double>(l[2]);
    double dx,dy,dz;
    SingleParticlePos_t q,qp;
    do {
      dx = (static_cast<double>(alpha[0])+0.5)*dl;
      dy = (static_cast<double>(alpha[1])+0.5)*dm;
      dz = (static_cast<double>(alpha[2])+0.5)*dn;
      q[0] = -dx + dy + dz;
      q[1] =  dx - dy + dz;
      q[2] =  dx + dy - dz;

      if(foundinIRBZ(q))  add(q); // limit to the ir-reducible wedge

      alpha[0]++;
      if(alpha[0] > a1[0]) { alpha[0] = a0[0]; alpha[1] += 1;}      
      if(alpha[1] > a1[1]) { alpha[1] = a0[1]; alpha[2] += 1;}
      
    } while(alpha[2] <= a1[2]);

    setweight();
    return true;

  } else { 
    N = SingleParticlePos_t(1.0,1.0,1.0);
    //K.push_back(new vector<SingleParticlePos_t>);
    //K[0]->push_back(SingleParticlePos_t(0.0,0.0,0.0));
    //W.push_back(1.0e0);
    return true;
  }
}

////////////////////////////////////////////////////////////
// build q, k-k' index map
// virtual bool KPointBase::foundinIRBZ(const SingleParticlePos_t&)
// is used to select q points within the IRBZ
// Derived class can overwrite foundinIRBZ (see, BCCKPoint)
////////////////////////////////////////////////////////////
void BCCKPoint::build_k_plus_q(){

  // assumes that N[0] == N[1] == N[2]
  double dl = 0.5/N[0];
  int l = static_cast<int>(N[0]/2);

  // set unique q's within the ir-reducile wedge
  typedef vector<SingleParticlePos_t> QArray_t;
  QArray_t qset;

  // 001 direction
  SingleParticlePos_t qp;
  for(int iq=0; iq<l; iq++) {
    qp[0] = -dl*iq;
    qp[1] = -qp[0];
    qp[2] = -qp[0];
    qset.push_back(qp);
  }

  // 011 direction
  for(int iq=0; iq<l; iq++) {
    qp[0] = dl*iq;
    qp[1] = 0;
    qp[2] = 0;
    qset.push_back(qp);
  }

  // 111 direction
  for(int iq=0; iq<l; iq++) {
    qp[0] = dl*iq;
    qp[1] = qp[0];
    qp[2] = qp[0];
    qset.push_back(qp);
  }

//   for(int iq=0; iq<=l; iq++) {
//     for(int jq=0; jq<=l; jq++) {
//       for(int kq = 0; kq<=n; kq++) {
//         SingleParticlePos_t dr(dl*iq, dm*jq, dn*kq);
//         fold2BZ(dr); 
//         if(foundinIRBZ(dr)) qset.insert(dr);
//       }
//     }
//   }

  int numpairs = NumKpt*NumKpt;
  vector<int> ndeg(numpairs);
  int qindex = 0;

  Q.reserve(qset.size()); // 
  QArray_t::iterator it = qset.begin();

  while(it != qset.end()) {
    for(int ip=0; ip<numpairs; ip++) ndeg[ip] = 0;// reset
    int itot = 0;
    for(int ik=0; ik<NumKpt; ik++) {
      for(int jk=0; jk<K[ik]->size(); jk++) {
	SingleParticlePos_t kp = (*K[ik])[jk] + *it;
	fold2BZ(kp); // fold the trial k' into a BZ
	int i = find(kp);
	if(i >= 0) { ndeg[ik*NumKpt+i] += 1; itot++;}
      }
    }
    if(itot>0) {
      Q.push_back(*it);
      KplusQ.push_back(vector<int>(numpairs));
      for(int ip=0; ip<numpairs; ip++) KplusQ[qindex][ip] = ndeg[ip];
      qindex++;
    }
    it++;
  }

}

// void BCCKPoint::k_plus_q(){

//   double dl = 0.5/N[0];
//   double dm = 0.5/N[1];
//   double dn = 0.5/N[2];
//   int l = static_cast<int>(N[0]/2);
//   int m = static_cast<int>(N[1]/2);
//   int n = static_cast<int>(N[2]/2);
//   double bcc0 = LatRef->p()(0,1); // returns 1/a0

//   // set unique q's within the ir-reducile wedge
//   typedef set<SingleParticlePos_t, ltpos<SingleParticlePos_t> > QArray_t;
//   QArray_t qset;

//   SingleParticlePos_t qp;
//   for(int iq=0; iq<=l; iq++) {
//     for(int jq=0; jq<=l; jq++) {
//       for(int kq = 0; kq<=n; kq++) {
//         SingleParticlePos_t dr(dl*iq, dm*jq, dn*kq);
//         fold2BZ(dr); 
//         qp = LatRef->toUnit(dr);
//         if((qp[2] >= 0) &&
//            (qp[0] <= bcc0) && (qp[1] <= qp[0]) && (qp[2] <= qp[1]) &&
//            (qp[0]+qp[1] <= bcc0) )  qset.insert(dr);
//       }
//     }
//   }

//   int numpairs = NumKpt*NumKpt;
//   vector<int> ndeg(numpairs);
//   int qindex = 0;

//   Q.reserve(qset.size()); // 
//   QArray_t::iterator it = qset.begin();

//   while(it != qset.end()) {
//     for(int ip=0; ip<numpairs; ip++) ndeg[ip] = 0;// reset
//     int itot = 0;
//     for(int ik=0; ik<NumKpt; ik++) {
//       for(int jk=0; jk<K[ik]->size(); jk++) {
// 	SingleParticlePos_t kp = (*K[ik])[jk] + *it;
// 	fold2BZ(kp); // fold the trial k' into a BZ
// 	int i = find(kp);
// 	if(i >= 0) { ndeg[ik*NumKpt+i] += 1; itot++;}
//       }
//     }
//     if(itot>0) {
//       Q.push_back(*it);
//       KplusQ.push_back(vector<int>(numpairs));
//       for(int ip=0; ip<numpairs; ip++) KplusQ[qindex][ip] = ndeg[ip];
//       qindex++;
//     }
//     it++;
//   }

//   for(int i=0; i<Q.size(); i++) {
//     cout << Q[i] << endl;
//     int ii=0, itot = 0;;
//     for(int ik=0; ik<NumKpt; ik++) {
//       for(int jk=0; jk<NumKpt; jk++) {
//         itot += KplusQ[i][ii];
//         cout << KplusQ[i][ii++] << " ";
//       }
//       cout << endl;
//     }
//     cout << "Total = " << itot << endl;
//   }      
//   KplusQ.erase(KplusQ.begin(), KplusQ.end());
//   for(int iq=0; iq<Q.size(); iq++) {
//     KplusQ.push_back(vector<int>(NumKpt*NumKpt+1)); 
//     int itot = 0;
//     for(int ik=0; ik<NumKpt; ik++) {
//       for(int jk=0; jk<K[ik]->size(); jk++) {
//         SingleParticlePos_t kp = (*K[ik])[jk] + Q[iq];
//         fold2BZ(kp); // fold the trial k' into a BZ
//         int i = find(kp);
//         if(i >= 0) { KplusQ[iq][ik*NumKpt+i] += 1; itot++;}
//       }
//     }    
//     KplusQ[NumKpt*NumKpt] = itot;
//     if(itot>0) {
//       cout << "total number of pairs = " << itot << endl;
//     }
//   }
// POSSIBLE to choose special directions
//   // TODO: sorting + symmetry
//   // (00x), Cubic: Delta line    
//   typedef CAS_DEFS::Scalar_t Scalar_t;
//   const Scalar_t smallval = 1e-6;
//   SingleParticlePos_t normal(0.0,0.0,1.0), kk;
//   QArray_t::iterator it = qset.begin();
//   while(it!=qset.end()) {
//     kk = LatRef->toUnit(*it);
//     Scalar_t cosine = 1-dot(normal,kk)/sqrt(dot(kk,kk));
//     if (cosine< smallval)  Q.push_back(*it);
//     it++;
//   }
//   // (0xx), Cubic: Sigma line 
//   const Scalar_t oneoversqrt2 = 1.0e0/sqrt(2.0e0);
//   normal = SingleParticlePos_t(0.0,oneoversqrt2,oneoversqrt2);
//   it = qset.begin();
//   while(it!=qset.end()) {
//     kk = LatRef->toUnit(*it);
//     Scalar_t cosine = 1-dot(normal,kk)/sqrt(dot(kk,kk));
//     if (cosine< smallval)  Q.push_back(*it);
//     it++;
//   }
//   // (xxx), Cubic: Lambda line 
//   const Scalar_t oneoversqrt3 = 0.5773502691896257645091487805019574556475;
//   normal = SingleParticlePos_t(oneoversqrt3,oneoversqrt3,oneoversqrt3);
//   it = qset.begin();
//   while(it!=qset.end()) {
//     kk = LatRef->toUnit(*it);
//     Scalar_t cosine = 1-dot(normal,kk)/sqrt(dot(kk,kk));
//     if (cosine< smallval)  Q.push_back(*it);
//     it++;
//   }
//   // (1 x 1-x),  BCC: F line
//   //normal = SingleParticlePos_t(0.5,0.5,-0.5);
//   //SingleParticlePos_t kH = LatRef.toUnit(normal);
//   //normal = (1.e0/sqrt(dot(kH,kH)))*kH;
//   normal = SingleParticlePos_t(oneoversqrt3,oneoversqrt3,-oneoversqrt3);
//   it = qset.begin();
//   while(it!=qset.end()) {
//     kk = LatRef->toUnit(*it);
//     Scalar_t cosine = 1-dot(normal,kk)/sqrt(dot(kk,kk));
//     // is it necessary?
//     // Scalar_t compre = kk[1] + kk[2] - 1.0;
//     //if ( (cosine< smallval) && (compre<smallval) )
//     if(cosine < smallval)  Q.push_back(*it);
//     it++;
//   }                           
//}


/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: BCCKPoint.cpp 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
