      subroutine atftm1(iut,r,v,x,f0,ib,ty,ndim9,ihg,nat,nc,ai,li,isy)

c     written on september 11th, 1979 - from acmi complex
c     auxiliary subroutine to group1
c     subroutine atftmt determines the point group of the crystal,
c     the atom transformation table,f0, the fractional translations,v,
c     associated with each rotation.
c subroutines needed: rlv3

      implicit none
      integer iut,ndim9,ihg,nat,nc,li,isy
      integer iis(48), ib(48)
      double precision  rx(3,250), vr(3), vt(3), xb(3)
      double precision r(49,3,3), v(3,48), x(3,ndim9),ai(3,3)
      integer f0(48,ndim9),ty(ndim9)
      integer i,j,k,il,k1,k2,k3,k4,nca,ks,l,n,ni
      double precision eps,da,dif,epsil,vs
      parameter ( eps = 1.0d-4 )
c
      character*12 icst(7)
      data icst /'triclinic','monoclinic','orthorhombic','tetragonal',
     &'cubic','trigonal','hexagonal'/
c-----------------------------------------------------------------------
      if (ndim9 .le. 250) goto 90
      write (iut,80) ndim9
80    format('subroutine atftm1 *** fatal error *** ndim9=',i4,'> 250')
      stop
c
90    nca = 0
      do 100 n = 1,48
        iis(n) = 0
100     continue
c
      do 210 n = 1,nc
c
        l = ib(n)
        iis(l) = 1
c       create a set of rotated cartesian coordinates for all 
c       atoms, using rotations 1 through nc
        do 120 k = 1,nat
          do 120 i = 1,3
            rx(i,k) = 0.0
            do 120 j = 1,3
              rx(i,k)=rx(i,k)+r(l,i,j)*x(j,k)
120     continue
c       write(6,1) n,l
c   1   format(' Below 120, n, l =',2i5)

c       Take all differences between original and rotated cartesian coords
c       for atoms of the same type (integer ty)
        do 180 k1 = 1,nat
        do 180 k2 = 1,nat
c         drop to bottom of loop for different types
          if (ty(k1) .ne. ty(k2)) go to 180
          do 130 i=1,3
            xb(i)=rx(i,k1)-x(i,k2)
130       continue
          il = 0
          call rlv3 (ai,xb,vr,il)
c     subroutine rlv removes a direct lattice vector from xb leaving the
c     remainder in vr.  if a nonzero lattice vector was removed, il is
c     made nonzero.  vr stands for v-reference.
c vr is not given in cartesian coordinates but
c in the system a1,a2,a3.     k.k., 23.10.1979

          ks = 0
          do 170 k3 = 1,nat
          do 160 k4 = 1,nat
c           drop to bottom of inner loop for different types
            if (ty(k3) .ne. ty(k4)) then
c            write(6,5)
c   5        format(' Different types, goto 160')
             go to 160
            endif
c           again take difference between original and rotated cartesian
c           coords and remove lattice vectors
            do 140 i = 1,3
              xb(i) = rx(i,k3) - x(i,k4)
140           continue
            call rlv3 (ai,xb,vt,il)
c           vt stands for v-test

            dif = 0.0
            do 150 i = 1,3
              da = abs(vr(i) - vt(i)) + eps
              dif = dif + dmod(da,1.d0)
150         continue
            if (dif .gt. 0.001) then
c            Not same nonsymmorphic translation ==> skip to end of loop
c            write(6,2) n,l,k1,k2,k3,k4,ks
c   2        format(' Below 150;  n,k,k1,k2,k3,k4,ks=',7i4,' goto 160')
             go to 160
            endif
c           same translation ==> might be a symmetry
            f0(n,k3)=k4
c           write(6,3) n,l,k1,k2,k3,k4,ks
c   3       format(' Keeper:     n,k,k1,k2,k3,k4,ks=',7i4)
c     f0 is the function defined in maradudin and vosk0 by eq.(2.35).
c     it defines the atom transformation table.
c     Operation number ib(n) of the space group, together with its
c     nonprimitive translation v(n), transfers atom k3 into atom f0(n,k3).
            ks = ks + k4
            if (ks .eq. nat*(nat+1)/2 ) then
c            a value of k4 has occurred for every 1,2,3,...,nat  ??
             go to 190
            endif
            go to 170
160         continue
          go to 180
170       continue
180     continue

      iis(l) = 0
      go to 210
190   nca = nca + 1
      do 200 i = 1,3
        v(i,nca)=vr(i)
200     continue
c     v(i,n) is the i-th component of the fractional
c     translation associated with the rotation n.
c attention: v(i) are not cartesian components, they are
c given in the system a1,a2,a3.     k.k., 23. 10. 1979
c
210     continue
c
      i  = 0
      ni = 13
      if (ihg .lt. 6) ni = 25
      li = 0
c     collapse down to the final set of symmetries
      do 230 n = 1,nc
        l = ib(n)
        if (iis(l) .eq. 0) go to 230
        i = i + 1
        ib(i) = ib(n)
        if (ib(i) .eq. ni) li = i
        do 220 k = 1,nat
          f0(i,k) = f0(n,k)
220     continue
230   continue
      nc = i
      if (ihg .eq. 7 .and. nc .eq. 24) go to 250
      if (ihg .eq. 5 .and. nc .eq. 48) go to 250
      write (iut,240) icst(ihg),(ib(i),i=1,nc)
240   format (' the crystal system is ',a,' with operations:'/
     &2(3x,24i3/))
      go to 270
250   write (iut,260) icst(ihg)
260   format ('the point group of the crystal is the full ',a,
     &' group')
270   vs = 0.0
      do 280 n = 1,nc
      do 280 i = 1,3
        vs = vs + abs(v(i,n))
280     continue
      epsil = 0.0005
c the original value epsil=0.0001 was modified
c by k.k. , september 1979
      if (vs .gt. epsil) go to 300
      write (iut,*) 'the space group of the crystal is symmorphic'
      isy = 1
      return
300   write (iut,310)
310   format ('the space group is non-symmorphic,'/
     &' or else a non standard origin of coordinates was used.')
      isy = 0
      return
      end
