      subroutine pgl1 (a,ai,ihc,nc,ib,ihg,r)
c                written on september 11th, 1979 - from acmi complex
c auxiliary subroutine to group1
c     subroutine pgl determines the point group of the lattice and the
c     crystal system.
c subroutines needed: rot1, rlv3
c a ..... direct lattice vectors
c ai .... reciprocal lattice vectors
      implicit none
      integer ihc,ihg,nc
      double precision  r(49,3,3),a(3,3), ai(3,3), vr(3), xa(3)
      integer ib(48)
      integer nr,n,k,i,j,lx
      double precision tr
c
c-----------------------------------------------------------------------
      ihc = 0
c     ihc is 0 for hexagonal groups and 1 for cubic groups.
      nr = 24
100   nc = 0
c     rot1 generates the cartesian transformation matrices for 
c     hexagonal or cubic groups, 24 or 48 elements
      call rot1 (ihc,r)
      do 140 n = 1,nr
        ib(n) = 0
        tr = 0.0
c       rotate the a1,2,3 vectors by rotation no. n
c       (these vectors are given in cartesian coordinates)
        do 130 k = 1,3
          do 110 i = 1,3
            xa(i) = 0.0
            do 110 j = 1,3
              xa(i) = xa(i) + r(n,i,j)*a(j,k)
110       continue
c         remove primitive translations from the rotated vector xa
          call rlv3 (ai,xa,vr,lx)
c         look at remaining nonprimitive translation; > 0 ?
          do 120 i = 1,3
            tr = tr + abs(vr(i))
120         continue
c         if vr.ne.0, then xa cannot be a multiple of a lattice vector
          if (tr .gt. 0.001) goto 140
130     continue

c       When all three original primitive translations a1,2,3 are
c       transformed by transformation n, the resulting set of three
c       vectors are a linear combination of the original set with
c       integral coefficients (no nonprimitive translation)

        nc = nc + 1
        ib(nc) = n
140     continue

c     nc is the number of symmetries of the crystal

c     ihg stands for holohedral group number
c      ihg .... point group of the primitive lattice, holohedral
c               group number:
c               ihg=1 stands for triclinic system
c               ihg=2 stands for monoclinic system
c               ihg=3 stands for orthorhombic system
c               ihg=4 stands for tetragonal system
c               ihg=5 stands for cubic system
c               ihg=6 stands for trigonal system
c               ihg=7 stands for hexagonal system
c               (holohedry is the point group of the lattice)

      if (ihc.eq.0) then

c      Do tests relevant to hexagonal or trigonal systems

       if (nc  .eq. 12) then
c        trigonal
         ihg = 6
       else if (nc  .gt. 12) then
c       must be hexagonal
        ihg=7
       else
c       must not be trigonal or hexagonal; try cubic group
        nr = 48
        ihc = 1
        goto 100
       endif

      else

c      Do tests relevant to cubic etc systems

c      triclinic
       if (nc  .lt. 4)  ihg = 1
c      monoclinic
       if (nc  .eq. 4)  ihg = 2
c      orthorhombic
       if (nc  .gt. 4)  ihg = 3
c      tetragonal
       if (nc  .eq. 16) ihg = 4
c      cubic
       if (nc  .gt. 16) ihg = 5
      endif

      return
      end
