c
c****************pointg
c
*     indexes of bravais lattice and point group
*     *************************************************
*     ========== ibrav is the structure index:=========
*     __ibrav__|__structure__|__ibrav__|___structure___
*     =================================================
*     |    1    | cubic p(sc) |    2    | cubic f(fcc)|
*     |    3    | cubic i(bcc)|    4    | hex. tri. p |
*     |    5    | hex. tri. r |    6    | tetra. p(sc)|
*     |    7    |tetra. i(bct)|    8    | ortho. p    |
*     |   12    | monoclinic p|   14    | triclinic p |
*     =================================================
*
*     =======pg is the point-group index==============
*
*     |_pg_|group|_pg_|group|_pg_|group|_pg_|group|
*     |===========================================|
*     | 1  | c1  |  9 | c3v | 17 | d4h | 25 | d2  |
*     | 2  | ci  | 10 | d3d | 18 | c6  | 26 | c2v |
*     | 3  | c2  | 11 | c4  | 19 | c3h | 27 | d2h |
*     | 4  | c1h | 12 | s4  | 20 | c6h | 28 |  t  |
*     | 5  | c2h | 13 | c4h | 21 | d6  | 29 |  th |
*     | 6  | c3  | 14 | d4  | 22 | c6v | 30 |  o  |
*     | 7  | c3i | 15 | c4v | 23 | d3h | 31 |  td |
*     | 8  | d3  | 16 | d2d | 24 | d6h | 32 |  oh |
*     |===========================================|
c
      subroutine pointg(iut,ibrav,inpgd,s,ntot,iinv)
c Input:
c  iut=output unit
c  ibrav=Bravais lattice index (in [1,14])
c  inpgd=point group index (in [1,32])
c Output:
c  s(3,3,ntot)=(integer) symmetry rotations EXPRESSED in terms of their
c   operation on the primitive translation vectors in real space
c  ntot=number of symmetry elements
c  iinv=1 for inversion; 0 otherwise


      implicit none

      integer iut,ibrav,inpgd,ntot,iinv
      integer s(3,3,48)
      character* 14 cbravs(14)
      character*4 cptg(32)
      integer i,j
      data cbravs/' cubic p (sc) ',' cubic f(fcc) ',' cubic i(bcc) ',
     &              ' hex. trig. p ',' hex. trig. r ',' tetra. p(st) ',
     &              ' tetra. i(bct)',' ortho. p     ','              ',
     &              '              ','              ',' monoclinic p ',
     &              '              ',' triclinic p  '/ 
      data cptg / ' c1 ', ' ci ', ' c2 ', ' c1h', ' c2h', ' c3 ',
     &            ' c3i', ' d3 ', ' c3v', ' d3d', ' c4 ', ' s4 ',
     &            ' c4h', ' d4 ', ' c4v', ' d2d', ' d4h', ' c6 ',
     &            ' c3h', ' c6h', ' d6 ', ' c6v', ' d3h', ' d6h',
     &            ' d2 ', ' c2v', ' d2h', ' t  ', ' th ', ' o  ',
     &            ' td ', ' oh ' /
c
      do 101 i = 1, 3
      do 101 j = 1, 3
      s(i,j,1) = 0
101   continue
      do 102 i = 1, 3
      s(i,i,1) = 1
102   continue
      iinv = 0
      if(inpgd .eq. 2)  iinv = 1
      if(inpgd .eq. 5)  iinv = 1
      if(inpgd .eq. 7)  iinv = 1
      if(inpgd .eq. 10) iinv = 1
      if(inpgd .eq. 13) iinv = 1
      if(inpgd .eq. 17) iinv = 1
      if(inpgd .eq. 20) iinv = 1
      if(inpgd .eq. 24) iinv = 1
      if(inpgd .eq. 27) iinv = 1
      if(inpgd .eq. 29) iinv = 1
      if(inpgd .eq. 32) iinv = 1
c
      if(inpgd .le. 0)return
      if(ibrav .le. 0)return

      if(ibrav.eq.2) then
      call fccsym(inpgd,s,ntot,iut)
      else if(ibrav.eq.3) then
      call bccsym(inpgd,s,ntot,iut)
      else if(ibrav.eq.5)then
      call trgsym(inpgd,s,ntot,iut)
      else if(ibrav.eq.7)then
      call bctsym(inpgd,s,ntot,iut)
      else 
      call pgsymo(inpgd,s,ntot,iut)
      end if 
      write(iut,401) cbravs(ibrav)
401   format(/' bravais lattice is -->',a14)
      write(iut,402) cptg(inpgd)
402   format(/' point group is -->', a4) 
      if(iinv .eq. 0) then
      write(iut,403)
      else
      write(iut,404)
      endif
403   format(/' no inversion symmetry in the point group')
404   format(/' inversion symmetry in the point group')
c
      return
      end
