      subroutine recip(a1,a2,a3,b1,b2,b3,vol)
c Compute unit cell volume and reciprocal lattice primitive translations,
c the latter in bohr^-1, WITHOUT the factor of 2*Pi which is sometimes used.
c i.e. (b1 b2 b3) = inverse(transpose (a1 a2 a3)  )  )

      implicit none
      double precision a1(3),a2(3),a3(3),b1(3),b2(3),b3(3),vol
      double precision t1,t2,t3,det,den

c     Compute determinant of (a1 a2 a3)
      t1 = a2(2) * a3(3) - a2(3) * a3(2)
      t2 = a2(3) * a3(1) - a2(1) * a3(3)
      t3 = a2(1) * a3(2) - a2(2) * a3(1)
      det = a1(1) * t1 + a1(2) * t2 + a1(3) * t3
      vol = abs(det)
      den = 1.d0/det

      b1(1) = t1 * den
      b1(2) = t2 * den
      b1(3) = t3 * den
      b2(1) = (a1(3)*a3(2)-a1(2)*a3(3))*den
      b2(2) = (a1(1)*a3(3)-a1(3)*a3(1))*den
      b2(3) = (a1(2)*a3(1)-a1(1)*a3(2))*den
      b3(1) = (a1(2)*a2(3)-a1(3)*a2(2))*den
      b3(2) = (a1(3)*a2(1)-a1(1)*a2(3))*den
      b3(3) = (a1(1)*a2(2)-a1(2)*a2(1))*den

      return
      end
