//////////////////////////////////////////////////////////////////
// (c) Copyright 2004-  by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NANOSIM_H
#define OHMMS_NANOSIM_H
#include "AppBase/OhmmsElementSet.h"

namespace OHMMS {

  /** A main node to perform electronic structure calculation of a large system
   *
   * Using Arpack library to obtain eigen values and vectors.
   */
  struct NanoSim: public OhmmsElementBase {
    
    // constructors and destructors
    NanoSim(OhmmsElementSet& nodelist, const char* aname="nanosim");
    
    bool get(std::ostream& os) const;
    bool put(std::istream& is);
    bool put(xmlNodePtr cur);
    
    void reset() {}
    private:
    OhmmsElementSet& NodeList;
  };

}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 159 $   $Date: 2004-11-03 16:13:18 -0600 (Wed, 03 Nov 2004) $
 * $Id: NanoSim.h 159 2004-11-03 22:13:18Z jnkim $ 
 ***************************************************************************/
