//////////////////////////////////////////////////////////////////
// (c) Copyright 2003  by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NEBRUN_H__
#define OHHMS_NEBRUN_H__

#include "OhmmsElementSet.h"

namespace OHMMS {

  class DimerPropagator;

  class DimerRun: public OhmmsElementBase {

  public:
    // constructors and destructors
    DimerRun(OhmmsElementSet& nodelist, const char* aname="dimersim");

    bool get(std::ostream& os) const;
    bool put(std::istream& is);
    bool put(xmlNodePtr cur);
    void reset();

  private:

    int blocks;
    int dimer_steps;
    int relax_steps;
    int dimer_stride;
    int relax_stride;
    double max_cpu; // maximum CPU time

    OhmmsElementSet& NodeList;
    bool initSearch(DimerPropagator&, xmlNodePtr cur);
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: DimerRun.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
