//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_ELECTRONPHONONCOUPLING_H
#define OHMMS_ELECTRONPHONONCOUPLING_H

#include "OhmmsData/OhmmsElementBase.h"
#include "Particle/OhmmsParticle.h"
#include "QuantumBase/ElectronStructure.h"
#include "RecordPropertyList.h"
#include "OhmmsElementSet.h"

namespace OHMMS {

  /**class to calculate ElectronPhononCoupling constants
   */
  class ElectronPhononCoupling: public OhmmsElementBase { 

  public:

    ElectronPhononCoupling(OhmmsElementSet& nodelist, const char* aname="electronphonon");
    ~ElectronPhononCoupling();
 
    bool get(ostream& os) const;
    bool put(istream& is);
    bool put(xmlNodePtr cur);
    void reset();

  protected:

    OhmmsElementSet& NodeList;
    Scalar_t Width;
    vector<vector<int>* > eband;
    vector<Scalar_t> DeltaE;
    vector<PhononMode> Phonon;
    vector<ParticlePos_t*> phonon;
    bool action(bool fullmatrix);
    RecordPropertyList RecordList;
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: ElectronPhononCoupling.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
