//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_IONICPOTENTIAL_H__
#define OHMMS_IONICPOTENTIAL_H__

#include "OhmmsData/OhmmsElementBase.h"
#include "Potentials/PotentialBase.h"
#include <map>

namespace OHMMS {

  class IonicPotential: public OhmmsElementBase {

  public:

    typedef PotentialBase Interaction_t;

    /// constructors and destructors
    IonicPotential(const char* aname="potential");
    
    ~IonicPotential();

    bool get(ostream& os) const;

    bool put(istream& is);

    bool put(xmlNodePtr cur);

    void reset();

    PotentialBase* get();
    const PotentialBase* get() const { return m_pot;}
    bool addRecord(RecordPropertyList& reclist, xmlNodePtr cur);

  private:

    int pot_type;
    PotentialBase* m_pot;
    map<int,PotentialBase*> pReserve;
    xmlNodePtr playout_ptr;
  };

}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 317 $   $Date: 2005-03-01 17:13:41 -0600 (Tue, 01 Mar 2005) $
 * $Id: IonicPotential.h 317 2005-03-01 23:13:41Z jnkim $ 
 ***************************************************************************/
