//////////////////////////////////////////////////////////////////
// (c) Copyright 2003  by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_MDRUNDATA_H__
#define OHHMS_MDRUNDATA_H__

#include "AppBase/OhmmsElementSet.h"
#include "AppBase/ParticleSets.h"
#include "OhmmsApp/IonicPotential.h"
#include "OhmmsApp/PropagatorBuilder.h"
#include <map>
#include <queue>
#include <string>

namespace OHMMS {

  class ProjectData;

  class MDRun: public OhmmsElementBase {

  public:
    // constructors and destructors
    MDRun(OhmmsElementSet& nodelist, const char* aname="mdsim");

    bool get(std::ostream& os) const;
    bool put(std::istream& is);
    bool put(xmlNodePtr cur);
    void reset();

  private:

    OhmmsElementSet& NodeList;
    std::queue<xmlNodePtr> RecordList;
    bool performMDLoops(std::vector<xmlNodePtr>&);

    ProjectData*                     _project;
    ParticleSets::Particle_t*        _particleset;
    PropagatorBuilder::Propagator_t* _propagator;
    IonicPotential::Interaction_t*   _potential;
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 254 $   $Date: 2005-01-14 11:40:45 -0600 (Fri, 14 Jan 2005) $
 * $Id: MDRun.h 254 2005-01-14 17:40:45Z jnkim $ 
 ***************************************************************************/
