//////////////////////////////////////////////////////////////////
// (c) Copyright 2003  by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NEBRUN_H__
#define OHHMS_NEBRUN_H__

#include "Particle/ParticleSet.h"
#include "OhmmsData/RecordProperty.h"
#include "AppBase/OhmmsElementSet.h"

namespace OHMMS {

  //class NEBPropagator;
  //class RecordPropagator;
  class SaveParticle;
  class NEBPotential;
  class NEBPropagator;
  class RecordNEB;
  class PropagatorBase;

  class NEBRun: public OhmmsElementBase {

  public:
    // constructors and destructors
    NEBRun(OhmmsElementSet& nodelist, const char* aname="nebsim");

    bool get(ostream& os) const;
    bool put(istream& is);
    bool put(xmlNodePtr cur);
    void reset();

  private:
    typedef ParticleSet                       Particle_t;
    typedef Particle_t::ParticleIndex_t       ParticleIndex_t;
    typedef Particle_t::ParticlePos_t         ParticlePos_t;
    typedef Particle_t::ParticleScalar_t      ParticleScalar_t;

    OhmmsElementSet& NodeList;
    RecordNamedProperty<int> I;
    vector<int> ChainIndex;
    string RestartConfig;
    ///NEB potential
    NEBPotential* nebPot;
    ///NEB Propagator
    NEBPropagator* nebMover;
    RecordNEB* nebRecorder;
    xmlNodePtr ptcl_ptr;
    vector<Particle_t*> Images;
    vector<SaveParticle*> ptcl_save;

    void DistributeChains();
    void MakeChains();
    void ExchangeEnds();
    bool DoNEB();

  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 382 $   $Date: 2005-09-05 15:24:49 -0500 (Mon, 05 Sep 2005) $
 * $Id: NEBRun.h 382 2005-09-05 20:24:49Z jnkim $ 
 ***************************************************************************/
