//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PROPGATORBUILDER_H__
#define OHMMS_PROPGATORBUILDER_H__

#include "OhmmsData/OhmmsElementBase.h"
#include "Propagators/PropagatorBase.h"

namespace OHMMS {

  class PropagatorBuilder: public OhmmsElementBase {

  public:

    typedef PropagatorBase Propagator_t;

    /// constructors and destructors
    PropagatorBuilder(const char* aname="ensemble");
    
    bool get(ostream& os) const;
    bool put(istream& is);
    bool put(xmlNodePtr cur);
    void reset();

    PropagatorBase* get();
    PropagatorBase* getCopy();
    const PropagatorBase* get() const { return m_mover;}

    /** create a PropagatorBase by the class name
     *@param pname the name of the subclass of PropagatorBase
     */
    PropagatorBase* createPropagator(const string& pname);

  private:
    int mover_type;
    PropagatorBase* m_mover;
    xmlNodePtr m_cur;
    std::string getPropagatorName(int mtype, const string& integrator);
  };

}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 242 $   $Date: 2005-01-13 09:42:50 -0600 (Thu, 13 Jan 2005) $
 * $Id: PropagatorBuilder.h 242 2005-01-13 15:42:50Z jnkim $ 
 ***************************************************************************/
