//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_RECORDPROPERTYLIST_H__
#define OHMMS_RECORDPROPERTYLIST_H__

#include "OhmmsData/RecordProperty.h"
#include "AppBase/OhmmsElementSet.h"
#include <stack>

namespace OHMMS {

  class RecordPropertyListManager: 
    public OhmmsElementBase,
    public RecordPropertyList{

  public:

    RecordPropertyListManager(OhmmsElementSet& nodelist, 
			      const char* aname="record");

    ~RecordPropertyListManager();

    bool get(std::ostream& os) const;
    bool put(std::istream& is);
    bool put(xmlNodePtr cur);
    void reset();

    /** prepare to add a group of records will be added **/
    void push_back();
    /** reset the last group of records **/
    void reset_top();
    /** remove the last group of records **/
    void pop_back();

  private:

    /// A pool of OhmmeElementBase*
    OhmmsElementSet& NodeList;

    /// a stack to operate on a group of records
    std::stack<int> NewRecord;

    /// the root name set by reset()
    std::string CurrentRoot;

    //bool addRecords(xmlXPathObjectPtr result);
  };

}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 157 $   $Date: 2004-11-03 16:10:50 -0600 (Wed, 03 Nov 2004) $
 * $Id: RecordPropertyList.h 157 2004-11-03 22:10:50Z jnkim $ 
 ***************************************************************************/
