//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2003 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

/***************************************************************************
 *
 ***************************************************************************/
#ifndef OHMMS_ESSL_SYM_SPARSESOLVERS_H
#define OHMMS_ESSL_SYM_SPARSESOLVERS_H
#include "OhmmsNumeric/SparseEigenSolver.h"
#include "EigSolver/EsslSymSolver.h"
namespace OHMMS {

  /**class to solve eigen problems of an input sparse matrix using EsslSymSolver
   *@brief Essl eigen solver use either packed or normal matrix
   */
  struct EsslSym: public SymEigenSolver {

    typedef EsslSymSolver<Scalar_t,PackedSymMatrix_t,RealMatrix_t> PackedSolver_t;
    typedef EsslSymSolver<Scalar_t,RealMatrix_t,RealMatrix_t> UnpackedSolver_t;

    PackedSolver_t *Solver1;
    UnpackedSolver_t *Solver2;

    PackedSolver_t::HamiltonianMatrix_t H1, S1;
    UnpackedSolver_t::HamiltonianMatrix_t H2, S2;    

    EsslSym(EigenSpaceDimension& space);

    ~EsslSym();

    void getEigvectors(SparseMatrix_t& hmat, RealMatrix_t& E);
    void getEigvalues(SparseMatrix_t& hmat, RealMatrix_t& E);

    void getEigvectors(SparseMatrix_t& hmat, SparseMatrix_t& smat, 
		       RealMatrix_t& E);
    void getEigvalues(SparseMatrix_t& hmat, SparseMatrix_t& smat, 
		      RealMatrix_t& E);
  };

}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: EsslSymSparseSolvers.h 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
