//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2003 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

/***************************************************************************
 *
 ***************************************************************************/
#ifndef OHMMS_LAPACK_COMPLEX_SPARSESOLVERS_H
#define OHMMS_LAPACK_COMPLEX_SPARSESOLVERS_H
#include "OhmmsNumeric/SparseEigenSolver.h"
#include "SparseMatrix/SparseMatrix2MatrixCopy.h"
#include "EigSolver/LapackSymSolverPacked.h"

namespace OHMMS {

  /**class to solve eigen problems of an input sparse matrix using LapaclPackedSymSolver for complex wave functions
   */
  struct LapackHerA: public HerEigenSolver {

    typedef 
    LapackPackedSymSolver<value_type,PackedHerMatrix_t,ComplexMatrix_t> 
    Solver_t;

    Solver_t *thisSolver;
    Solver_t::HamiltonianMatrix_t H, S; 

    LapackHerA(EigenSpaceDimension& space): 
      HerEigenSolver(space), thisSolver(NULL) 
    {  }

    ~LapackHerA();

    void getEigvectors(const SparseMatrix_t& hmat, const ComplexMatrix_t& phi, 
		       RealMatrix_t& E, int first, int last);
    void getEigvalues(const SparseMatrix_t& hmat, const ComplexMatrix_t&, 
		      RealMatrix_t& E, int first, int last);
    void getEigvectors(const SparseMatrix_t& hmat, const SparseMatrix_t& smat, 
		       const ComplexMatrix_t& phi, RealMatrix_t& E, 
		       int first, int last);
    void getEigvalues(const SparseMatrix_t& hmat, const SparseMatrix_t& smat, 
		      const ComplexMatrix_t& phi, RealMatrix_t& E,
		      int first, int last);
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 378 $   $Date: 2005-08-28 18:40:33 -0500 (Sun, 28 Aug 2005) $
 * $Id: LapackHerSparseSolvers.h 378 2005-08-28 23:40:33Z jnkim $
 ***************************************************************************/
