//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2003 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

/***************************************************************************
 *
 ***************************************************************************/
#ifndef OHMMS_LAPACKPACKEDSPARSEREALSOLVER_H
#define OHMMS_LAPACKPACKEDSPARSEREALSOLVER_H
#include "OhmmsNumeric/SparseEigenSolver.h"
#include "EigSolver/LapackSymSolverPacked.h"

namespace OHMMS {

  struct LapackRealA: public RealEigenSolver {

    typedef LapackPackedSymSolver<Scalar_t,PackedSymMatrix_t,RealMatrix_t> 
    SymSolver_t;
    SymSolver_t *thisSolver;

    LapackRealA(int n, int m): RealEigenSolver(n,m), thisSolver(NULL) 
    {  }


    void getEigvectors(const SparseMatrix_t& hmat, RealMatrix_t& E);
    void getEigvalues(const SparseMatrix_t& hmat, RealMatrix_t& E);
    void getEigvectors(const SparseMatrix_t& hmat, const SparseMatrix_t& smat, 
		       RealMatrix_t& E);
    void getEigvalues(const SparseMatrix_t& hmat, const SparseMatrix_t& smat, 
		      RealMatrix_t& E);
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: LapackPackedSparseSolver.cpp 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
