//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2003 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

/***************************************************************************
 *
 ***************************************************************************/
#ifndef OHMMS_LAPACKREALSPARSESOLVERS_H
#define OHMMS_LAPACKREALSPARSESOLVERS_H
#include "OhmmsNumeric/SparseEigenSolver.h"
#include "SparseMatrix/SparseMatrix2MatrixCopy.h"
#include "EigSolver/LapackSymSolverPacked.h"

namespace OHMMS {

  /**class to solve eigen problems of an input sparse matrix using LapaclPackedSymSolver
   */
  struct LapackSymA: public SymEigenSolver {

    typedef LapackPackedSymSolver<real_type,PackedSymMatrix_t,RealMatrix_t> 
    SymSolver_t;
    SymSolver_t *thisSolver;
    SymSolver_t::HamiltonianMatrix_t H, S; 

    LapackSymA(EigenSpaceDimension& space): 
      SymEigenSolver(space), thisSolver(NULL) 
    {  }

    ~LapackSymA();

    void getEigvectors(SparseMatrix_t& hmat, RealMatrix_t& E);
    void getEigvalues(SparseMatrix_t& hmat, RealMatrix_t& E);
    void getEigvectors(SparseMatrix_t& hmat, SparseMatrix_t& smat, 
		       RealMatrix_t& E);
    void getEigvalues(SparseMatrix_t& hmat, SparseMatrix_t& smat, 
		      RealMatrix_t& E);
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 378 $   $Date: 2005-08-28 18:40:33 -0500 (Sun, 28 Aug 2005) $
 * $Id: LapackSymSparseSolvers.h 378 2005-08-28 23:40:33Z jnkim $
 ***************************************************************************/
