//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////

#ifndef EVENTDETECTORBASE_H
#define EVENTDETECTORBASE_H

#include <string>
#include <vector>
using namespace std;

#include "Particle/OhmmsParticle.h"
using namespace OHMMS;

class EventDetectorBase {

public:

  typedef Particle_t::SingleParticlePos_t SingleParticlePos_t;
  typedef Particle_t::ParticlePos_t       ParticlePos_t;
  typedef Particle_t::ParticleScalar_t    ParticleScalar_t;

  EventDetectorBase(int argc, char **argv);
  EventDetectorBase(vector<string>& );
  EventDetectorBase();
  virtual ~EventDetectorBase();

  void initialize(Particle_t* p, const char*);
  virtual bool detect(ParticlePos_t&, Scalar_t& drmaxsq);

  void getoptions(vector<string>& );
  void setRefConfig(ParticlePos_t&, ParticleScalar_t&);
  void saveRefConfig(int );

protected:
  int Counter;
  int LocalNum;
  bool AdjustCM, TraceBC;
  Scalar_t Rcut;
  string FileRoot;

  vector<string> Species;
  vector<string> options;
  Particle_t* PtclRef;
  SingleParticlePos_t RefCM;
  ParticlePos_t RefPos, DeltaR, AccumBC;
  ParticleScalar_t RefEne, Ene;
};
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: EventDetectorBase.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/

