//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#include "Message/OpenMP.h"
#include "Message/Communicate.h"
#include "Particle/NNInfiniteEngine.h"
#include "ParticleBase/ParticleUtility.h"
using namespace OHMMS;

NNInfiniteEngine::NNInfiniteEngine(){
  setID(ThisMethod);
}

NNInfiniteEngine::~NNInfiniteEngine() { 
}

/** prepare the spatial grid to perform linked-cell calculations
 *@param p the particle whose neighbor lists are evaluated by this engine.
 *@param rmax the maximum interaction radius
 *@return true NNRegiGridEngine uses the cell index of the current configuration
 * 
 *- make a linked-cell list with the spatial grid
 *- apply boundary conditions to the current position p.R
 *- create the data sets for each grid
 *- update the layout information, such as cell indices with p.R
 *- partition the local particles over the number of threads
 */ 
bool
NNInfiniteEngine::initialize(Particle_t& p, bool needvisitingforce) {

  return true;
}

void 
NNInfiniteEngine::evalPairsPerThread(const ParticleLayout_t& lattice, 
                  const ParticlePos_t& pos, 
                  PtclPairList_t& myppl) {
}

bool NNInfiniteEngine::putExtra(xmlNodePtr cur){
  return true;
}

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 305 $   $Date: 2005-02-16 11:33:52 -0600 (Wed, 16 Feb 2005) $
 * $Id: NNInfiniteEngine.cpp 305 2005-02-16 17:33:52Z jnkim $ 
 *******************************************************************/
