//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NNMINIMALENGINE_H
#define OHMMS_NNMINIMALENGINE_H

#include "Particle/NNEngine.h"

/*\class NNMinimalEngine
 *\brief Using 1x1x1 grid with infinite interaction radius
 */
namespace OHMMS {

  class NNInfiniteEngine: public NNEngine {

    public:

    enum {ThisMethod = 4};

    typedef Particle_t::ParticlePos_t       ParticlePos_t;
    typedef Particle_t::SingleParticlePos_t SingleParticlePos_t;

    NNInfiniteEngine();
    ~NNInfiniteEngine();

    bool initialize(Particle_t& p, bool needvisitingforce);

  protected:

    void evalPairsPerThread(const ParticleLayout_t& lattice, 
                  const ParticlePos_t& pos, 
                  PtclPairList_t& myppl);
    
    bool putExtra(xmlNodePtr cur);
    //ParticleIndex_t Cell;
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 305 $   $Date: 2005-02-16 11:33:52 -0600 (Wed, 16 Feb 2005) $
 * $Id: NNInfiniteEngine.h 305 2005-02-16 17:33:52Z jnkim $ 
 ***************************************************************************/
