//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002,2003- by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NEARESTNEIGHBOR_REGULARGRIDENGINE_SAVE_H
#define OHMMS_NEARESTNEIGHBOR_REGULARGRIDENGINE_SAVE_H

#include "Particle/NNEngine.h"

/** The main engine to build the nearest-neighbor list
 *
 * Use the grid partition and search only the particles in itself
 * and connected cells. Both image cells and subgrids are supported.
 * The engine tends to use a rather big number to allocate the
 * memory for the pair lists to avoid frequent memory allocation.
 * Use <parameter name="maxnn">integer</parameter>
 * if the number of neighbors is known and never changes.
 */
namespace OHMMS {

  class NNRegGridEngine: public NNEngine {

    public:

    enum {ThisMethod = 0};

    typedef Particle_t::ParticlePos_t       ParticlePos_t;
    typedef Particle_t::SingleParticlePos_t SingleParticlePos_t;

    NNRegGridEngine();
    ~NNRegGridEngine();
   
    bool initialize(Particle_t& p, bool needvisitingforce);
    Index_t updateGridData(const ParticlePos_t& pos, ParticlePos_t& pu, ParticleLayout_t& lattice);

  protected:

    void evalPairsPerThread(const ParticleLayout_t& lattice, 
                            const ParticlePos_t& pos, 
                            const ParticleIndex_t& grID,
                            PtclPairList_t& myppl);
    bool putExtra(xmlNodePtr cur);
    
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 354 $   $Date: 2005-07-07 21:20:49 -0500 (Thu, 07 Jul 2005) $
 * $Id: NNRegGridEngine.h 354 2005-07-08 02:20:49Z jnkim $ 
 ***************************************************************************/
