//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_NEARESTNEIGHBOR_REGULARGRIDMETHOD_SAVE_H
#define OHMMS_NEARESTNEIGHBOR_REGULARGRIDMETHOD_SAVE_H

#include "Particle/NNMethodBase.h"
#include "Lattice/UniformGridConnection.h"

/*\class NNRegGridMethod
 *\brief Using grid partition
 */
namespace OHMMS {

  class NNRegGridMethod: public NNMethodBase {

    public:

    enum {ThisMethod = 0};

    typedef Particle_t::ParticlePos_t       ParticlePos_t;
    typedef Particle_t::SingleParticlePos_t SingleParticlePos_t;

    NNRegGridMethod();
    ~NNRegGridMethod();

    // virtual method to evaluate nearest-neighbor lists, indices
    void get(const Particle_t& p, PtclPairList_t& myppl, int myID);
    int init(Particle_t& p,Scalar_t rmax);
    void partition(Particle_t& );
    void updateR(Particle_t& p, const ParticlePos_t& pos);

    protected:

    bool putExtra(xmlNodePtr cur);

    UniformGridConnection<Scalar_t,OHMMS_DIM> NextCell;
    ParticleIndex_t CellID;

    ///displacement to ensure that all the particles are within a cell
    SingleParticlePos_t Shift;

  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: NNRegGridMethod.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
