//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_PARTICLE_INPUTOUTPUT_VASP_UTILITY_H
#define OHMMS_PARTICLE_INPUTOUTPUT_VASP_UTILITY_H

#include "OhmmsData/OhmmsElementBase.h"
#include "OhmmsData/RecordProperty.h"
#include "Particle/ParticleSet.h"

namespace OHMMS {

  class VaspParticleParser {

  public:

    typedef ParticleSet Particle_t;
    VaspParticleParser(Particle_t& aptcl):ref_(aptcl){ }

    ///reading from a file
    bool put(const char*);
 
  private:

    Particle_t& ref_;
    string m_title;
  };


  class VaspSaveParticle: public RecordProperty {

  public:

    typedef ParticleSet Particle_t;

    VaspSaveParticle(Particle_t& pin): ref_(pin){ }

    ~VaspSaveParticle();

    void reset(const char* fileroot);

    void report(int iter);

    void finalize() { }

    bool put(xmlNodePtr cur);

  private:

    Particle_t& ref_;
    string FileRoot;

  };
}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: VaspParticleIO.h 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
