//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_QUANTUMDOTIO_H
#define OHMMS_QUANTUMDOTIO_H

#include "ParticleBase/ParticleIOBase.h"
#include "Ohmms.h"
#include "Particle/OhmmsParticle.h"
using namespace OHMMS;


/*! \class XmolParticleIO
 *  \author Jeongnim Kim
 *  \brief A dervied class from ParticleIOBase
 *  
 *  Read/Write/Record in a format xmol can process.
 *  INPUT mode: filename 
 *  OUTPUT mode: --stride
 *  PROGRESS mode: --E/--V/--F --stride 
 */

class  QuantumDotIO: public ParticleIOBase<double,3> {

public:

  typedef double T;
  typedef ParticleIOBase<T,3>::ThisParticle_t ThisParticle_t;
  typedef ThisParticle_t::ParticlePos_t       ParticlePos_t;
  typedef ThisParticle_t::ParticleScalar_t    ParticleScalar_t;
  typedef ThisParticle_t::ParticleIndex_t     ParticleIndex_t;
  typedef ThisParticle_t::SingleParticlePos_t SingleParticlePos_t;
 
  QuantumDotIO(ThisParticle_t& p, int i, const char* name = NULL)
  :ParticleIOBase<T,3>(p,i,name) { }

  ~QuantumDotIO() {
    DEBUGMSG("calling QuantumDotIO::~QuantumDotIO() for " << FileRoot)
  }

  void read(); // read a configuration
  void write(){} // write a configuration for re-runs
  void record(int){ }// record a configuration (time-stepping)
  void finalize() { }

private:
};

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: QuantumDotIO.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
