// -*- C++ -*-
/***************************************************************************
 *
 * The POOMA Framework
 * 
 * This program was prepared by the Regents of the University of
 * California at Los Alamos National Laboratory (the University) under
 * Contract No.  W-7405-ENG-36 with the U.S. Department of Energy (DOE).
 * The University has certain rights in the program pursuant to the
 * contract and the program should not be copied or distributed outside
 * your organization.  All rights in the program are reserved by the DOE
 * and the University.  Neither the U.S.  Government nor the University
 * makes any warranty, express or implied, or assumes any liability or
 * responsibility for the use of this software
 *
 * Visit http://www.acl.lanl.gov/POOMA for more details
 *
 ***************************************************************************/

/***************************************************************************
 *
 * Simple routine to calculate 32-bit CRC, assuming 32-bit integers.
 * 
 ***************************************************************************/

#ifndef POOMA_MESSAGE_CRC_H
#define POOMA_MESSAGE_CRC_H

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned int CRCTYPE;

/* calculate the CRC for the given buffer of bytes, of length icnt */
CRCTYPE crc(void *icp, int icnt);

#ifdef __cplusplus
}
#endif


#endif // POOMA_MESSAGE_CRC_H

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * POOMA_VERSION_ID: $Id: CRC.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/

