//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_TEMPLATE_FOR_SHORTRANGEPOTENTIAL_H
#define OHMMS_TEMPLATE_FOR_SHORTRANGEPOTENTIAL_H

#include "Potentials/ShortRangePotential.h"

namespace OHMMS {

  /** An example of ShortRangePotential
   *
   *Implement virtual functions.
   */
  struct AShortRangePotential: public ShortRangePotential {

    AShortRangePotential();

    ~AShortRangePotential();

    void initialize();
    bool get(ostream&) const;
    bool put(istream&);
    void reset();
    bool put(xmlNodePtr cur);

    Scalar_t evalForceNN(PtclPairList_t& nnlist, 
			 ParticlePos_t& f0, 
			 ParticleScalar_t& q, 
			 unsigned stressmode);
    
    Scalar_t evalEnergyNN(const PtclPairList_t& nnlist, 
			  int first, int last);
    
  };


}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: AShortRangePotential.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
