//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_LJPOTENTIAL_H
#define OHMMS_LJPOTENTIAL_H

#include "Potentials/ShortRangePotential.h"
#include "ScaleFunctors/LJScale.h"
namespace OHMMS {

  class LJPotential:public ShortRangePotential {

  public:

    LJPotential();
    ~LJPotential() { }

    void initialize();
    bool put(xmlNodePtr cur);

    Scalar_t evalForceNN(PtclPairList_t& nnlist, 
			 ParticlePos_t& f0, 
			 unsigned stressmode) const;

    Scalar_t evalEnergyNN(const PtclPairList_t& nnlist, 
        Scalar_t rscale=1.0) const;

  protected:
    LJScale<Scalar_t>*  LJSet;  
  };
}
#endif


/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 308 $   $Date: 2005-02-21 09:21:44 -0600 (Mon, 21 Feb 2005) $
 * $Id: LJPotential.h 308 2005-02-21 15:21:44Z jnkim $ 
 ***************************************************************************/
