//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#include "Potentials/ShortRangePotential.h"

namespace OHMMS {

  //default constructor
  ShortRangePotential::ShortRangePotential():  
    DistScale(1.0),CollectVisitingForces(false)
  {}
  
  ShortRangePotential::~ShortRangePotential()
  {
  }
}
// ShortRangePotential::Scalar_t 
// ShortRangePotential::e(const ParticlePos_t&, int i, int myid) {
//   return 0.0;
// }

// bool ShortRangePotential::evalDynamicMatrix(DynMatrix_t&) {
//   return false;
// }


// ShortRangePotential::Scalar_t 
// ShortRangePotential::evalEnergy() {

//   myPtcl->getPairlist(Rmax);
//   Scalar_t esum = 0.0e0;
// #pragma omp parallel reduction(+:esum)
//   {

//     const NNEngine *nnListEngine = myPtcl->nnListEngine;
//     int myID = omp_get_thread_num();
//     esum += evalEnergyNN(nnListEngine->getPairAttrib(myID),
// 			 nnListEngine->first_id(myID),
// 			 nnListEngine->last_id(myID));
//   }//end-of-omp

//   return myPtcl->getNNEngine()->collect(esum);
// }


// ShortRangePotential::Scalar_t 
// ShortRangePotential::evalForce(ParticlePos_t& f, int i, int myid) {
//   return 0.0;
// }

// #ifdef ENABLE_OPENMP
// //this is test to compare the performance
// #define USE_PTCLPAIRLIST_DATA
// #if defined(USE_PTCLPAIRLIST_DATA)
// ShortRangePotential::Scalar_t 
// ShortRangePotential::evalForce(ParticlePos_t& f0, 
// 			       ParticleScalar_t& q, 
// 			       Tensor_t& stress, 
// 			       unsigned stressmode) {

//   myPtcl->getPairlist(Rmax);
//   NNEngine *nnListEngine = myPtcl->getNNEngine();
  
//   //============================================================
//   //Derived class will use ghost cells. Add ghost elements to f0
//   //============================================================
//   if(CollectVisitingForces) nnListEngine->startCollect(f0);
//   vector<Scalar_t> esumloc(nnListEngine->size());
//   vector<int> nfv(nnListEngine->size());
//   Scalar_t esum=0.0;

// #pragma omp parallel
//   {
//     int myID = omp_get_thread_num();
//     int nfv_est=0;
//     esumloc[myID]= evalForceNN(nnListEngine->getPairAttrib(myID),
//                                myID, 
//                                nnListEngine->first_id(myID),
// 			       nnListEngine->last_id(myID),
// 			       f0,q,nfv_est);
//     nfv[myID]=nfv_est;
// /** using omp critical: using a serial region below
//     Scalar_t x= evalForceNN(nnListEngine->getPairAttrib(myID),
//                             myID, 
//                             nnListEngine->first_id(myID),
//   			    nnListEngine->last_id(myID),
//   			    f0,q,nfv_est);
//   #pragma omp critical
//       {
//         esum += x;
//         const PtclPairList_t::IndexList_t& J = nnListEngine->getPairAttrib(myID).IDv;
//         const PtclPairList_t::VectorList_t& f = nnListEngine->getPairAttrib(myID).Fv;
//         for(int nni=0; nni<nfv_est; nni++) 
//           f0[J[nni]]+=f[nni];
//       }
// */
//   }

//   //Add the visiting forces
//   for(int myID=0; myID<nnListEngine->size(); myID++) {
//     esum += esumloc[myID];
//     const PtclPairList_t::IndexList_t& J = nnListEngine->getPairAttrib(myID).IDv;
//     const PtclPairList_t::VectorList_t& f = nnListEngine->getPairAttrib(myID).Fv;
//     for(int nni=0; nni<nfv[myID]; nni++) 
//       f0[J[nni]]+=f[nni];
//   }
//   if(CollectVisitingForces) nnListEngine->endCollect(f0);

// /** This should work fine but the code sometimes run incorrectly
// #pragma omp parallel
//   {
//     int myID = omp_get_thread_num();
//     int nfv_est=0;
//     if(CollectVisitingForces) {
//       if(!fv[myID]) fv[myID] = new ParticlePos_t;
//       if(!fvind[myID]) fvind[myID] = new ParticleIndex_t;
//       int nadj= 2*nnListEngine->getPairAttrib(myID).getTotNadj();
//       if(fv[myID]->size() < nadj) fv[myID]->resize(nadj);
//       if(fvind[myID]->size() < nadj) fvind[myID]->resize(nadj);
//     }
//     esumloc[myID] = evalForceNN(nnListEngine->getPairAttrib(myID),
//                                 myID,
//                                 nnListEngine->first_id(myID),
//                                 nnListEngine->last_id(myID),
// 				f0,*fv[myID],*fvind[myID],nfv_est);
//     nfv[myID]=nfv_est;
//   }    
  
//   Scalar_t esum = std::accumulate(esumloc.begin(), esumloc.end(),0.0);
//   if(CollectVisitingForces) {
//     for(int i=0; i<fv.size(); i++) {
//       const ParticlePos_t& f=*fv[i];
//       const ParticleIndex_t& J=*fvind[i];
//       for(int nni=0; nni<nfv[i]; nni++) {
// 	f0[J[nni]]+=f[nni];
//       }
//     }
//     //delegate to nnListEngine to collect forces among mpi
//     nnListEngine->endCollect(f0);
//   }
// */
//   return nnListEngine->collect(esum);
// }
// #else /* USE_PTCLPAIRLIST_DATA */

// ShortRangePotential::Scalar_t 
// ShortRangePotential::evalForce(ParticlePos_t& f0, 
// 			       ParticleScalar_t& q, 
// 			       Tensor_t& stress, 
// 			       unsigned stressmode) {

//   //This is identical to the serial version but adds a copy operation.
//   myPtcl->getPairlist(Rmax);
//   NNEngine *nnListEngine = myPtcl->nnListEngine;

//   //============================================================
//   //Derived class will use ghost cells. Add ghost elements to f0
//   //============================================================
//   if(CollectVisitingForces) nnListEngine->startCollect(f0);

//   Scalar_t esum = 0.0e0;
// #pragma omp parallel
//   {
//     int myID = omp_get_thread_num();
//     ParticlePos_t fv(myPtcl->getLocalNum());
//     Scalar_t esumloc = evalForceNN(nnListEngine->getPairAttrib(myID),
// 				   nnListEngine->first_id(myID),
// 				   nnListEngine->last_id(myID),
// 				   fv,q,stress,stressmode);
// #pragma omp critical
//     {
//       esum += esumloc;
//       f0 += fv;
//     }
//   }
//   //will delegate to nnListEngine to collect forces
//   if(CollectVisitingForces) nnListEngine->endCollect(f0);
//   return nnListEngine->collect(esum);
// } 
// #endif /* USE_PTCLPAIRLIST_DATA */
// #else /* ENABLE_OPENMP */

// ShortRangePotential::Scalar_t 
// ShortRangePotential::evalForce(ParticlePos_t& f0, 
// 			       ParticleScalar_t& q, 
// 			       Tensor_t& stress, 
// 			       unsigned stressmode) {

//   myPtcl->getPairlist(Rmax);
//   NNEngine *nnListEngine = myPtcl->nnListEngine;

//   //============================================================
//   //Derived class will use ghost cells. Add ghost elements to f0
//   //============================================================
//   if(CollectVisitingForces) nnListEngine->startCollect(f0);

//   int myID = 0;
//   Scalar_t esum = evalForceNN(nnListEngine->getPairAttrib(myID),
// 			      nnListEngine->first_id(myID),
// 			      nnListEngine->last_id(myID),
// 			      f0,q,stress,stressmode);
  
//   ///will delegate to nnListEngine to collect forces
//   if(CollectVisitingForces) nnListEngine->endCollect(f0);

//   return nnListEngine->collect(esum);
// }
// #endif  /* ENABLE_OPENMP */
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 354 $   $Date: 2005-07-07 21:20:49 -0500 (Thu, 07 Jul 2005) $
 * $Id: ShortRangePotential.cpp 354 2005-07-08 02:20:49Z jnkim $ 
 ***************************************************************************/

