// -*- C++ -*-
#include <vector>
using namespace std;
#include "Potentials/PotentialTemplate.h"
#include "Particle/NearestNeighborBase.h"
#include "Utilities/SpeciesCollection.h"
#include "Utilities/SimpleParser.h"

aPotential::aPotential(int argc, char **argv)
{

}

void aPotential::initialize() {

}
  

Scalar_t 
aPotential::e(ParticlePos_t& R, int i) {

  const PtclPairListBase* nnlist = nnListEngine->getPairAttrib();

  int nn =  nnlist->nadj(i);
 
  for(int jL=0; jL<nn; ++jL) {
    int j = nnlist->iadj(i,jL);  //atomic index of jL-th nn of i

    if(R.InUnit) 
      dr = myPtcl->Lattice.BConds.apply(R[j]-R[i]);
    else
      dr = myPtcl->Lattice.BConds.apply(myPtcl->Lattice.toUnit(R[j]-R[i]));

    r = sqrt(myPtcl->Lattice.Dot(dr,dr));

    // directional cosine if needed, uses
    dcos = myPtcl->Lattice.toCart(dr)*rinv;

    // add energy computations with r, using nnlist->R[loc] and nnlist->dR[loc]

  }
 
  return localQ;
}

Scalar_t 
aPotential::evalEnergy() {

   getPairList(); // using a pair-list
   //Reference to the container of Nearest Neighbor List
   const PtclPairListBase* nnlist = nnListEngine->getPairAttrib();

   int LocalNum = myPtcl->getLocalNum();

    for(int i=0; i< LocalNum; i++) {
     
      nn =  nnlist->nadj(i);
 
      for(int jL=0; jL<nn; ++jL) {
        int j = nnlist->iadj(i,jL);  //atomic index of jL-th nn of i
        int loc = nnlist->loc(i,jL); //location of R, dR of the pair


        // add energy computations using nnlist->R[loc] and nnlist->dR[loc]

      }
   }
 
  return localQ;
}

Scalar_t 
aPotential::evalForce(ParticlePos_t& f0, ParticleScalar_t& q,
                      Tensor_t& stress, unsigned stressmode) {

  getPairList(); // using a pair-list
  //Reference to the container of Nearest Neighbor List
  const PtclPairListBase* nnlist = nnListEngine->getPairAttrib();

  int LocalNum = myPtcl->getLocalNum();

  for(int i=0; i< LocalNum; i++) {
     
    nn =  nnlist->nadj(i);
 
    for(int jL=0; jL<nn; ++jL) {
      int j = nnlist->iadj(i,jL);  //atomic index of jL-th nn of i
      int loc = nnlist->loc(i,jL); //location of R, dR of the pair


      // add force computations using nnlist->R[loc] and nnlist->dR[loc]

    }
  }
 
  if(stressmode == 1) {
   psum /= 3.0e0;
   stress.diagonal(psum);
  }

  return esum;
}


PotentialBase::Scalar_t 
aPotential::evalDynamicMatrix(int iter, SimpleParticle& ) {

  return 0.0e0;

}
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: APotential.cpp 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/

