//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
/***************************************************************************
 * 
 * CGPROPAGATOR_H optimization using CG method
 * Implemented by Jeongnim Kim, 2001
 * Modified by Yaojun Du on May 2002
 * Modified by Jeongnim Kim on May/28/2002
 ***************************************************************************/

#ifndef OHMMS_CGPROPAGATOR_H
#define OHMMS_CGPROPAGATOR_H

#include "Propagators/PropagatorBase.h"
#include "Optimize/OptimizationBase.h"
//#include "Optimize/CGOptimization.h"

namespace OHMMS {
  /*!\class CGPropagator
   * \author Jeongnim Kim, Yaojun Du
   */
  class 
  CGPropagator: public PropagatorBase, 
    //private CGOptimization<PropagatorBase::ParticlePos_t> {
		private OptimizationBase {

  public:

    CGPropagator();
    ~CGPropagator() { }
 
    // implementing virutal functions
    void initialize(Particle_t* ptclin, Interaction_t* potin, bool makecopy = false);
    void setTemperature(bool rescale, Scalar_t tref); 
    bool propagate(Interaction_t*);
    void applyBConds(bool wrapping);

  protected:

    Return_t Func(Return_t dl);

    ParticlePos_t  CG, G0, Rtemp;
    Scalar_t       gdotg, gdotg0, gdoth, gamma;
    Scalar_t       d_pe_save, deltaEmax, gdotgmax, fmax;
    Scalar_t       lambdasum;
    bool           RestartCG;
    bool           FlexibleCell;
    int            CGmode;
    int            NumLineMin;
    size_type gdotg_ind, gdoth_ind;
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 354 $   $Date: 2005-07-07 21:20:49 -0500 (Thu, 07 Jul 2005) $
 * $Id: CGPropagator.h 354 2005-07-08 02:20:49Z jnkim $ 
 ***************************************************************************/
