//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_CONSTRAINTBASE_H
#define OHMMS_CONSTRAINTBASE_H

#include "Particle/ParticleSet.h"

namespace OHMMS {
struct ConstraintBase {

  typedef ParticleSet                 Particle_t;
  typedef Particle_t::Scalar_t        Scalar_t;
  typedef Particle_t::ParticlePos_t   ParticlePos_t;
  typedef Particle_t::ParticleIndex_t ParticleIndex_t;

  ConstraintBase();
  virtual ~ConstraintBase();

  Scalar_t dof();        //degree's of freedom
  void set(Particle_t*);
  virtual void apply(ParticlePos_t&);  
  void removeDrift(ParticlePos_t&);
  Particle_t* mySys;  // reference to a system
};
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: ConstraintBase.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
