//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_NOPROPAGATOR_H
#define OHMMS_NOPROPAGATOR_H

#include "Propagators/PropagatorBase.h"
#include "OhmmsData/OhmmsElementBase.h"

namespace OHMMS {
  /*!\class NoPropagator
   * \author Jeongnim Kim
   * \brief A propagator to calculate energy for the fixed configuration.
   */
  class NoPropagator: public PropagatorBase //, public OhmmsElementBase
  { 

  public:

    NoPropagator();
    ~NoPropagator() { }
 
    // implementing virutal functions
    void initialize(Particle_t* ptclin, Interaction_t* potin, bool makecopy = false);
    void setTemperature(bool rescale, Scalar_t tref); 
    bool propagate(Interaction_t*);
    void applyBConds(bool wrapping);
    void setGetForce(bool getforce) { GetForce = getforce;}
  protected:
    size_type exx_ind,eyy_ind,ezz_ind,exy_ind,eyz_ind,ezx_ind;
    bool ForceUnitR;
    bool GetForce;
    bool GetPressure;
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 354 $   $Date: 2005-07-07 21:20:49 -0500 (Thu, 07 Jul 2005) $
 * $Id: NoPropagator.h 354 2005-07-08 02:20:49Z jnkim $ 
 ***************************************************************************/
