//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#include "Propagators/PropagatorBase.h"
#include "Propagators/RecordPropagator.h"

namespace OHMMS {

  void RecordPropagator::reset(const char* fileroot) {
    string fname=fileroot;
    fname.append(".dynamics.dat");
    ref_.E.reset(fname.c_str());
  }

  void RecordPropagator::report(int iter) {
    if(iter<0) return;
    ref_.E.report(iter);
  }


  bool RecordPropagator::put(xmlNodePtr cur) {
    return ref_.E.put(cur);
  }

  /////////////////////////////////////
  //functions ot SavePropagator
  /////////////////////////////////////
  void SavePropagator::reset(const char* fileroot){
    string fname=fileroot;
    fname.append(".log");
    ref_.E.reset(fname.c_str());
  }

  void SavePropagator::report(int iter) {

  }

  bool SavePropagator::put(xmlNodePtr cur) {
  

//   stride = atoi((const char*)(xmlGetProp(cur, (const xmlChar *) "stride")));
//   const char* FileFormat 
//     = (const char*)(xmlGetProp(cur, (const xmlChar *) "format"));
  
  return true;
  }

}
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 202 $   $Date: 2004-12-22 10:35:48 -0600 (Wed, 22 Dec 2004) $
 * $Id: RecordPropagator.cpp 202 2004-12-22 16:35:48Z jnkim $ 
 ***************************************************************************/
