//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002,2003- by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
///////////////////////////////////////////////////////////////////////
// * This class implements the orthogonal tight-binding model
// * of Harrison scale, i.e., (r0/r)^2 
/////////////////////////////////////////////////////////////////////
#ifndef OHMMS_SLATERKOSTERTB_GSPTB_H
#define OHMMS_SLATERKOSTERTB_GSPTB_H

#include "SlaterKosterTB/TBModelBase.h"
#include "ScaleFunctors/GSPScale.h" 

namespace OHMMS {

  class GSPTB:public TBModelBase {

  public:

    typedef GSPScale<Scalar_t> ScaleFunction_t;

    GSPTB();
    ~GSPTB();

    //////////////////////////////////////////////
    // virtual function of TBModelBase
    //////////////////////////////////////////////
    ShortRangePotential* 
    init(SKList_t& SK_h, SKList_t& SK_s, Matrix<int>& bond, istream& fin);

  protected:

    vector<vector<ScaleFunction_t>* > V;

    /*
    void set(Particle_t* ptclset);

    /// implementing virtual functions for OhmmsElementBase
    bool get(ostream&) const;
    bool put(istream&);
    bool put(xmlNodePtr cur);
    void reset();

    void setParticleSet(Particle_t* ptclin) { myPtcl = ptclin;}

    Scalar_t evalForceNN(PtclPairList_t& nnlist, 
			 ParticlePos_t& f0, 
			 ParticleScalar_t& q, 
			 unsigned stressmode) const;

    Scalar_t evalEnergyNN(const PtclPairList_t& nnlist, 
                          Scalar_t rscale=1.0) const;

  protected:
    ///////////////////////////////////
    // data members
    ///////////////////////////////////
    // classical part
    bool   EnvDep;
    ScaleFunction_t Phi; 
    vector<Scalar_t>   fc;
    //vector<Scalar_t> dphi;

    // qautum part

    Scalar_t evalForce_with_env(PtclPairList_t& nnlist, 
				  ParticlePos_t& f0, 
				  ParticleScalar_t& q, 
				  unsigned stressmode) const;

    Scalar_t evalForce_paironly(PtclPairList_t& nnlist, 
				ParticlePos_t& f0, 
				ParticleScalar_t& q, 
				unsigned stressmode) const;
  */
  };
}

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 330 $   $Date: 2005-05-26 17:44:25 -0500 (Thu, 26 May 2005) $
 * $Id: GSPTB.h 330 2005-05-26 22:44:25Z jnkim $ 
 ***************************************************************************/
