//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_SLATERKOSTERTB_INVPOWERLAWTB_H
#define OHMMS_SLATERKOSTERTB_INVPOWERLAWTB_H

#include "SlaterKosterTB/TBModelBase.h"
#include "ScaleFunctors/InvPowerScale.h"

namespace OHMMS {

  struct InvPowerTB: public TBModelBase {

    typedef InvPowerScaleN<Scalar_t,0>  ConstantType;
    typedef InvPowerScaleN<Scalar_t,-1> GeneralPowerLawType;

    vector<vector<ConstantType>* > Vc;
    vector<vector<GeneralPowerLawType>* > Vg;

    InvPowerTB();
    ~InvPowerTB();
    
    //////////////////////////////////////////////
    // virtual function of TBModelBase, will return NULL
    //////////////////////////////////////////////
    ShortRangePotential*
    init(SKList_t& SK_h, SKList_t& SK_s, Matrix<int>& bond, istream& fin);
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 352 $   $Date: 2005-06-16 09:12:55 -0500 (Thu, 16 Jun 2005) $
 * $Id: InvPowerTB.h 352 2005-06-16 14:12:55Z jnkim $ 
 ***************************************************************************/
