//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_SLATERKOSTER_LENOSKYTB_H
#define OHMMS_SLATERKOSTER_LENOSKYTB_H

#include "SlaterKosterTB/TBModelBase.h"
#include "Potentials/ShortRangePotential.h"

#include "ScaleFunctors/CubicSplineOverR2.h" 
#ifndef CUBICSPLINEFUNCTIONS_H
#include "ScaleFunctors/CubicSplineFunctions.h" 
#endif

namespace OHMMS {

  class LenoskyTB: public TBModelBase {
    
  public:

    typedef CubicSplineOverR2<Scalar_t> ScaleFunction_t;

    LenoskyTB();
    ~LenoskyTB();

    //////////////////////////////////////////////
    // virtual function of TBModelBase
    //////////////////////////////////////////////
    ShortRangePotential*
    init(SKList_t& SK_h, SKList_t& SK_s, Matrix<int>& bond, istream& fin);


  protected:
    ///////////////////////////////////
    // data members
    ///////////////////////////////////
    vector<vector<ScaleFunction_t>* > V;
  };
}
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 330 $   $Date: 2005-05-26 17:44:25 -0500 (Thu, 26 May 2005) $
 * $Id: LenoskyTB.h 330 2005-05-26 22:44:25Z jnkim $ 
 ***************************************************************************/
