//////////////////////////////////////////////////////////////////
//                        COPYRIGHT NOTICE
//   (c) Copyright 1998-2002 Jeongnim Kim.
//   All rights reserved.
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_SLATERKOSTERTB_SCF_H
#define OHMMS_SLATERKOSTERTB_SCF_H

#include "Particle/OhmmsParticle.h"
#include "SparseMatrix/SparseMatrix.h"

namespace OHMMS {
  struct TBSCFBase {

    TBSCFBase();
    virtual ~TBSCFBase();
    Scalar_t HubbardU, MixingRatio, MaxIter, Etol; 


    /////////////////////////////////////////////////////
    // \todo TEMPORARY solution for SCC calculations
    // HubbardU should be a property of a species
    // MixingRatio should be algorithm dependent
    // But, on Mon May 20 17:25:19 CDT 2002, make them data members.
    /////////////////////////////////////////////////////
    void set(Particle_t*, const vector<string>&);
    virtual Scalar_t SCFCorrection(SparseMatrix_t& h, SparseMatrix_t& rho, int iter=0);
    virtual Scalar_t SCFCorrection(SparseMatrix_t& h, SparseMatrix_t& s, 
				   SparseMatrix_t& rho, int iter=0);
    Particle_t* myPtcl;
  };
}
#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * POOMA_VERSION_ID: $Id: TBSCFBase.h 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
