//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002,2004- by Lars Jonsson and Jeongnim Kim
//////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#ifndef OHMMS_NUMAINFO
#define OHMMS_NUMAINFO

class NumaInfo {

  private:

   int table[4][1024];
   int Ncpus;
   int Nnodes;
   int Nthreads;
   char hname[10];
   
  public:

   int get_node(int proc) { return table[3][proc];}
   int get_module(int proc) { return table[1][proc];}
   int get_slot(int proc) { return table[2][proc];}
   int get_proc(int thread) { return table[0][thread];}
   int get_num_cpus() { return Ncpus;}
   int get_num_nodes() { return Nnodes;}
   int get_num_threads() { return Nthreads;}
   void print_host_info();
   void print_thread_info();
   NumaInfo();
   ~NumaInfo() { }
};
#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 185 $   $Date: 2004-11-18 20:40:37 -0600 (Thu, 18 Nov 2004) $
 * $Id: NumaInfo.h 185 2004-11-19 02:40:37Z jnkim $ 
 ***************************************************************************/

