//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   Jeongnim Kim
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_SPARSEINDEX_COMPOSITE_H
#define OHMMS_SPARSEINDEX_COMPOSITE_H
#include "SparseMatrix/SparseIndexOMP.h"

/*! \class VectorIndex
 * A specialized sparse index class for TB Hamiltonian matrices
 * Has a reference to PairList and creates extra indices.
 */
struct SparseIndexComposite: public SparseIndexOMP {

  SparseIndexComposite(const char* = "none");

  ~SparseIndexComposite(); // myList has to be provided externally

  void init(const SparseIndexOMP*, int nshell,  const NS_t& ns, const NS_t& nb);
  void init(const SparseIndexOMP*, const SparseIndexOMP*,
            const NS_t& ns, const NS_t& nb);

  virtual void update();
  void update(int, int*, int*);

  int NumShell;
  const SparseIndexOMP* baseA;
  const SparseIndexOMP* baseB;

};

#endif
/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * OHMMS_VERSION: $Id: SparseIndexComposite.h 151 2004-11-02 23:51:14Z jnkim $
 ***************************************************************************/
