//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-
#ifndef OHMMS_SIMPLEPARSER_H
#define OHMMS_SIMPLEPARSER_H

#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <list>
#if (__GNUC__ == 2)
#include <strstream.h>
#else
#include <sstream>
#endif
using namespace std;

char* readLine(char *s, int max, istream &fp);

template <class C>
inline std::size_t parsewords(char* inbuf, C& slist) {
  const char* token = "=, \t\n\"";

  char *tmpstr = new char[strlen(inbuf)+1];
  strcpy(tmpstr, inbuf);
  slist.erase(slist.begin(), slist.end());

  std::size_t num = 0;
  char* tokenp = strtok(tmpstr, token);
  while(tokenp && tokenp[0] != '#') {
    num++;
    slist.push_back(string(tokenp));
    tokenp = strtok(0,token);
  }

  delete [] tmpstr;
  return num;
}

std::size_t getwords(vector<string>& slist, istream &fp);
std::size_t getwords(vector<string>& slist,istream& fpos, const char* field, const char* terminate);
std::size_t getwords(vector<string>& slist,istream& fpos, const char* terminate);
std::size_t getXwords(vector<string>& slist, istream &fp);
std::size_t getXwords(vector<string>& slist,istream& fpos, const char* terminate);
//std::size_t parsewords(char *inbuf, vector<string>& slist);
//std::size_t parsewords(char *inbuf, vector<string>& slist);
//unsigned parsewords(char *inbuf, list<string>& slist);

void readXmol(istream& ,double*,int);

#endif

/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 354 $   $Date: 2005-07-07 21:20:49 -0500 (Thu, 07 Jul 2005) $
 * $Id: SimpleParser.h 354 2005-07-08 02:20:49Z jnkim $ 
 ***************************************************************************/
