//////////////////////////////////////////////////////////////////
// (c) Copyright 1998-2002 by Jeongnim Kim
//
//   National Center for Supercomputing Applications &
//   Materials Computation Center
//   University of Illinois, Urbana-Champaign
//   Urbana, IL 61801
//   e-mail: jnkim@ncsa.uiuc.edu
//   Tel:    217-244-6319 (NCSA) 217-333-3324 (MCC)
//
// Supported by 
//   National Center for Supercomputing Applications, UIUC
//   Materials Computation Center, UIUC
//   Department of Physics, Ohio State University
//   Ohio Supercomputer Center
//////////////////////////////////////////////////////////////////
// -*- C++ -*-

#include "Utilities/GlobalMDParameters.h"
#include "Utilities/MDParameters.h"
#include "Message/Communicate.h"

MDParameters* GlobalMDParameters::mdparam = NULL;

GlobalMDParameters::~GlobalMDParameters() 
{ 
  if(mdparam) delete mdparam; 
}

void GlobalMDParameters::init(int argc, char** argv) {

  if(!mdparam) {
    mdparam = new MDParameters;
  }
  mdparam->set(argc,argv);
}

/*! \fn GlobalMDParameters::getMDParameters()
 *  \return pointer to static MDParameter
 *  \brief Returns Singleton MDParameter*
 */ 
MDParameters* GlobalMDParameters::getMDParameters(){
  if(!mdparam) {
    mdparam = new MDParameters;
  }
  return mdparam;
}

/*! \fn GlobalMDParameters::getMDParameters(int argc, char** argv)
 *  \param argc Number of arguments
 *  \param argv A list of arguments
 *  \brief Returns Singleton MDParameter* as well as add/assign a parameter
 */ 
MDParameters* GlobalMDParameters::getMDParameters(int argc, char** argv){
  GlobalMDParameters::init(argc,argv);
  return mdparam;
}

/*! \fn GlobalMDParameters::getMDParameters(vector<string>& vlist)
 *  \param vlist A list of argyments
 *  \brief Returns Singleton MDParameter* as well as adds/assigns a parameter
 */ 
MDParameters* GlobalMDParameters::getMDParameters(vector<string>& vlist){
  if(!mdparam) {
    mdparam = new MDParameters;
  }
  mdparam->set(vlist);
  return mdparam;
}


/***************************************************************************
 * $RCSfile$   $Author: jnkim $
 * $Revision: 151 $   $Date: 2004-11-02 17:51:14 -0600 (Tue, 02 Nov 2004) $
 * $Id: GlobalMDParameters.cpp 151 2004-11-02 23:51:14Z jnkim $ 
 ***************************************************************************/
